<?php
    
    if(!defined('ABSPATH')){
    	exit;
	}
    
    class iCal {
        
        public $prefix = null;
        
        public $setting = null;
        
        public function __construct($prefix) {
            
            $this->prefix = $prefix;
            $this->setting = new setting($prefix);
            
        }
        
        public function isValid($token){
            
            #var_dump($token);
            $booking_sync = $this->setting->getBookingSyncList();
            $booking_sync = $booking_sync['iCal'];
            
            if(intval($booking_sync['booking_app_ical_active']['value']) == 1 && $booking_sync['booking_app_ical_token']['value'] == $token){
                
                #var_dump($booking_sync);
			    $this->getBookingSchedules();
                
                exit;
                
            }else{
                
                return false;
                
            }
            
        }
        
        public function getBookingSchedules(){
            
            $timezone = get_option('timezone_string');
		    date_default_timezone_set('UTC');
		    $unixTime = date('U') - (7 * 1440 * 60);
		    $gmtOffset = get_option('gmt_offset');
		    $gmtOffset = date('P');
		    $url_parce = parse_url(get_home_url());
		    $host = $url_parce["host"];
		    
		    print "BEGIN:VCALENDAR\n";
            print "PRODID:-//WP_BOOKING_APP/".$host."\n";
            print "VERSION:2.0\n";
            print "CALSCALE:GREGORIAN\n";
            print "METHOD:PUBLISH\n";
            print "X-WR-CALNAME:WP_BOOKING_APP\n";
            print "X-WR-TIMEZONE:".$timezone."\n";
            print "X-WR-CALDESC:\n";
		    
            $schedule = new Schedule($this->prefix);
            $response = $schedule->getReservationData(date('m', $unixTime), date('d', $unixTime), date('Y', $unixTime), true);
            #date_default_timezone_set('UTC');
            date_default_timezone_set($timezone);
            for($i = 0; $i < count($response); $i++){
                
                $bookingDetail = $response[$i];
                $summaryList = array();
                //DESCRIPTION
                
                $descriptionList = array();
                for($a = 0; $a < count($bookingDetail['praivateData']); $a++){
                    
                    $praivateData = $bookingDetail['praivateData'][$a];
                    if(isset($praivateData->isName) && $praivateData->isName == 'true'){
                        
                        array_push($summaryList, $praivateData->value);
                        
                    }
                    
                    if($praivateData->active == 'true'){
                        
                        array_push($descriptionList, $praivateData->name."\t".$praivateData->value);
                        
                    }
                    
                }
                
                $summary = "No title";
                if(count($summaryList) != 0){
                    
                    $summary = implode(" ", $summaryList);
                    
                }
                
                $description = implode("\\n", $descriptionList);
                
                
                $unixTime = $bookingDetail['date']['unixTime'];
                print "BEGIN:VEVENT\n";
                print "UID:".$bookingDetail['key']."@".$host."\n";
                print "DTSTART;TZID=".$timezone.":".date("Ymd\THi00", $unixTime)."\n";
                if(intval($bookingDetail['courseTime']) != 0){
                    
                    print "DTEND;TZID=".$timezone.":".date("Ymd\THi00", ($unixTime + ($bookingDetail['courseTime'] * 60)))."\n";
                    
                }else{
                    
                    print "DTEND;TZID=".$timezone.":".date("Ymd\THi00", $unixTime)."\n";
                    
                }
                print "DTSTAMP:".date("Ymd\THi00\Z")."\n";
                print "CREATED;TZID=".$timezone.":".date("Ymd\THi00", $bookingDetail['reserveTime'])."\n";
                print "DESCRIPTION:\n";
                print "STATUS:CONFIRMED\n";
                print "SEQUENCE:".($i + 1)."\n";
                print "SUMMARY:".$summary."\n";
                print "LOCATION:\n";
                print "DESCRIPTION:".$description."\n";
                print "END:VEVENT\n";
                #var_dump($bookingDetail['praivateData']);
                
            }
            
            
            print "END:VCALENDAR\n";
            
        }
        
        
    }



?>