<?php
    
    if(!defined('ABSPATH')){
    	exit;
	}
    
    class Schedule {
        
        public $prefix = null;
        
        public $pluginName = null;
        
        public $automaticApprove = false;
        
        public function __construct($prefix, $pluginName){
            
            $this->prefix = $prefix;
            $this->pluginName = $pluginName;
            $this->accommodationDetails = null;
            #$this->setting = new setting($this->prefix, $this->pluginName);
            
            global $wpdb;
            $table_name = $wpdb->prefix."booking_package_userPraivateData";
            #$wpdb->query("DROP TABLE IF EXISTS ".$table_name.";");
            
        }
        
        public function setAccommodationDetails($accommodationDetails){
        	
        	$this->accommodationDetails = $accommodationDetails;
        	
        }
        
        public function getAccommodationDetails(){
        	
        	return $this->accommodationDetails;
        	
        }
        
        public function createFirstCalendar(){
        	
        	global $wpdb;
        	$table_name = $wpdb->prefix."booking_package_calendarAccount";
        	$sql = "SELECT COUNT(`key`) FROM `".$table_name."`;";
			
			$sql = $wpdb->prepare("SELECT COUNT(`key`) FROM `".$table_name."`;", array());
			$rows = $wpdb->get_results($sql, ARRAY_A);
			foreach($rows as $row){
				
				if(intval($row['COUNT(`key`)']) == 0){
					
					#var_dump($row['COUNT(`key`)']);
    				$date = date('U');
    				$wpdb->insert(
    					$table_name, 
    					array(
    						'key' => 1, 
    						'name' => sanitize_text_field('First Calendar'), 
    						'type' => sanitize_text_field('day'), 
    						'status' => sanitize_text_field('open'), 
    						'created' => sanitize_text_field($date), 
    						'uploadDate' => sanitize_text_field($date)
    					), 
    					array('%d', '%s', '%s', '%s', '%s', '%s')
    				);
    				
    				$wpdb->insert(
    				$table_name, 
    					array(
    						'key' => 2, 
    						'name' => sanitize_text_field('First Calendar for hotel'), 
    						'type' => sanitize_text_field('hotel'), 
    						'status' => sanitize_text_field('open'), 
    						'created' => sanitize_text_field($date), 
    						'uploadDate' => sanitize_text_field($date),
    						'numberOfRoomsAvailable' => 5,
    						'includeChildrenInRoom' => 1
    					), 
    					array('%d', '%s', '%s', '%s', '%s', '%s', '%d', '%d')
    				);
    				$this->addGuests(2);
    				
    				/**
    				if($calendarAccountType != 0){
    					
    					$wpdb->insert(
    					$table_name, 
    						array(
    							'key' => 2, 
    							'name' => sanitize_text_field('First Calendar for hotel'), 
    							'type' => sanitize_text_field('hotel'), 
    							'status' => sanitize_text_field('open'), 
    							'created' => sanitize_text_field($date), 
    							'uploadDate' => sanitize_text_field($date),
    							'numberOfRoomsAvailable' => 5,
    							'includeChildrenInRoom' => 1
    						), 
    						array('%d', '%s', '%s', '%s', '%s', '%s', '%d', '%d')
    					);
    					
    					$this->addGuests(2);
    					
    				}
    				**/
    				
    				
				}
				
				break;
				
			}
			
			$this->insertAccountSchedule(date('m'), date('d'), date('Y'));
        	
        }
        
        public function getCalendarAccountListData($columns = "*"){
        	
        	global $wpdb;
        	$table_name = $wpdb->prefix."booking_package_calendarAccount";
			$sql = $wpdb->prepare("SELECT ".$columns." FROM `".$table_name."`;", array());
			$rows = $wpdb->get_results($sql, ARRAY_A);
			foreach($rows as $row){
				
				
				
			}
			
			return $rows;
        	
        }
        
        public function getCalendarAccount($accountKey = 1){
        	
        	global $wpdb;
        	$table_name = $wpdb->prefix."booking_package_calendarAccount";
			$sql = $wpdb->prepare("SELECT * FROM `".$table_name."` WHERE `key` = %d;", array($accountKey));
			$row = $wpdb->get_row($sql, ARRAY_A);
			if(strlen($row['type']) == 0){
				
				$row['type'] = 'day';
				
			}
			
			return $row;
        	
        }
        
        public function addCalendarAccount(){
        	
        	$postList = array('cost' => 0, 'numberOfRoomsAvailable' => 1, 'numberOfPeopleInRoom' => 2, 'includeChildrenInRoom' => 0);
        	foreach($postList as $key => $value){
        		
        		if(!isset($_POST[$key])){
        			
        			$_POST[$key] = $value;
        			
        		}
        		
        	}
        	
        	$type = "day";
        	if(isset($_POST['type'])){
        		
        		$type = $_POST['type'];
        		
        	}
        	
        	$date = date('U');
        	global $wpdb;
        	$table_name = $wpdb->prefix."booking_package_calendarAccount";
        	
        	$wpdb->insert(
    			$table_name, 
    			array(
    				'name' => sanitize_text_field($_POST['name']), 
    				'type' => sanitize_text_field($type), 
    				'status' => sanitize_text_field($_POST['status']), 
    				'courseTitle' => sanitize_text_field($_POST['courseTitle']), 
    				'courseBool' => intval($_POST['courseBool']),
    				'created' => sanitize_text_field($date), 
    				'uploadDate' => sanitize_text_field($date),
    				'cost' => intval($_POST['cost']),
    				'numberOfRoomsAvailable' => intval($_POST['numberOfRoomsAvailable']),
    				'numberOfPeopleInRoom' => intval($_POST['numberOfPeopleInRoom']),
    				'includeChildrenInRoom' => intval($_POST['includeChildrenInRoom']),
    				'expressionsCheck' => intval($_POST['expressionsCheck']),
    			), 
    			array('%s', '%s', '%s', '%s', '%d', '%s', '%s', '%d', '%d', '%d', '%d', '%d')
    		);
    		
    		$accountKey = $wpdb->insert_id;
    		$this->addGuests($accountKey);
    		if($type == 'hotel'){
    			
    			$this->insertAccountSchedule(date('m'), date('d'), date('Y'));
    			
    		}
    		
    		return $this->getCalendarAccountListData();
        	
        }
        
        public function updateCalendarAccount(){
        	
        	$postList = array('cost' => 0, 'numberOfRoomsAvailable' => 1, 'numberOfPeopleInRoom' => 2, 'includeChildrenInRoom' => 0);
        	foreach($postList as $key => $value){
        		
        		if(!isset($_POST[$key])){
        			
        			$_POST[$key] = $value;
        			
        		}
        		
        	}
        	
        	$date = date('U');
        	global $wpdb;
        	$table_name = $wpdb->prefix."booking_package_calendarAccount";
        	
        	$bool = $wpdb->update( 
        		$table_name,
				array(
					'name' => sanitize_text_field($_POST['name']), 
					'type' => sanitize_text_field($_POST['type']), 
					'status' => sanitize_text_field($_POST['status']), 
					'courseTitle' => sanitize_text_field($_POST['courseTitle']),
					'courseBool' => intval($_POST['courseBool']),
					'googleCalendarID' => sanitize_text_field($_POST['googleCalendarID']),
					'uploadDate' => date('U'),
					'cost' => intval($_POST['cost']),
    				'numberOfRoomsAvailable' => intval($_POST['numberOfRoomsAvailable']),
    				'numberOfPeopleInRoom' => intval($_POST['numberOfPeopleInRoom']),
    				'includeChildrenInRoom' => intval($_POST['includeChildrenInRoom']),
    				'expressionsCheck' => intval($_POST['expressionsCheck'])
				),
				array('key' => intval($_POST['accountKey'])),
				array('%s', '%s', '%s', '%s', '%d', '%s', '%d', '%d', '%d', '%d', '%d', '%d'),
				array('%d')
			);
			
        	if($bool === 1){
        		
        		return $this->getCalendarAccountListData();
        		
        	}else{
        		
        		return array("status" => $bool);
        		
        	}
        	
        	
        }
        
        public function updateCalendarAccountForGoogleWebhook($accountKey, $idForGoogleWebhook, $expirationForGoogleWebhook){
        	
        	global $wpdb;
        	$table_name = $wpdb->prefix."booking_package_calendarAccount";
        	
        	$bool = $wpdb->update( 
        		$table_name,
				array(
					'idForGoogleWebhook' => sanitize_text_field($idForGoogleWebhook), 
					'expirationForGoogleWebhook' => sanitize_text_field($expirationForGoogleWebhook)
				),
				array('key' => intval($accountKey)),
				array('%s', '%s', '%s'),
				array('%d')
			);
			
        	if($bool === 1){
        		
        		$key = $this->prefix."id_for_google_webhook";
        		if(get_option($key) === false){
        			
        			add_option($key, sanitize_text_field($idForGoogleWebhook));
        			
        		}else{
        			
        			update_option($key, sanitize_text_field($idForGoogleWebhook));
        			
				}
        		
        		return $this->getCalendarAccountListData();
        		
        	}else{
        		
        		return array("status" => $bool);
        		
        	}
        	
        	
        }
        
        
        
        public function lookingForGoogleCalendarId($googleCalendarId = false){
        	
        	global $wpdb;
        	$table_name = $wpdb->prefix."booking_package_calendarAccount";
        	if($googleCalendarId != false){
        		
        		$sql = $wpdb->prepare("SELECT `key`,`type`,`googleCalendarID`,`idForGoogleWebhook`,`expirationForGoogleWebhook` FROM ".$table_name." WHERE `idForGoogleWebhook` = %s;", array(sanitize_text_field($googleCalendarId)));
        		$row = $wpdb->get_row($sql, ARRAY_A);
				if(strlen($row['type']) == 0 || is_null($row['type'])){
					
					$row['type'] = 'day';
					
				}
        		
        		return $row;
        		
        	}
        	
        	return null;
        	
        }
        
        public function deleteCalendarAccount(){
        	
        	global $wpdb;
        	
        	$table_name = $wpdb->prefix."booking_package_form";
        	$wpdb->delete($table_name, array('accountKey' => intval($_POST['accountKey'])), array('%d'));
        	
        	$table_name = $wpdb->prefix."booking_package_courseData";
        	$wpdb->delete($table_name, array('accountKey' => intval($_POST['accountKey'])), array('%d'));
        	
        	$table_name = $wpdb->prefix."booking_package_schedule";
        	$wpdb->delete($table_name, array('accountKey' => intval($_POST['accountKey'])), array('%d'));
        	
        	$table_name = $wpdb->prefix."booking_package_templateSchedule";
        	$wpdb->delete($table_name, array('accountKey' => intval($_POST['accountKey'])), array('%d'));
        	
        	$table_name = $wpdb->prefix."booking_package_calendarAccount";
        	$wpdb->delete($table_name, array('key' => intval($_POST['accountKey'])), array('%d'));
        	
        	$table_name = $wpdb->prefix."booking_package_emailSetting";
        	$wpdb->delete($table_name, array('accountKey' => intval($_POST['accountKey'])), array('%d'));
        	
        	$table_name = $wpdb->prefix."booking_package_guests";
        	$wpdb->delete($table_name, array('accountKey' => intval($_POST['accountKey'])), array('%d'));
        	
        	$table_name = $wpdb->prefix."booking_package_userPraivateData";
        	$wpdb->delete($table_name, array('accountKey' => intval($_POST['accountKey'])), array('%d'));
        	
        	return $this->getCalendarAccountListData();
        	
        }
        
        public function addGuests($accountKey){
        	
        	global $wpdb;
        	
        	$guestsList = array(
    			0 => array("number" => 1, "price" => 0, "name" => "1 adult"),
    			1 => array("number" => 2, "price" => 0, "name" => "2 adults"),
    		);
    		$table_name = $wpdb->prefix."booking_package_guests";
    		$wpdb->insert(
    			$table_name, 
    			array(
    				'accountKey' => intval($accountKey), 
    				'name' => "Number of adults", 
    				'target' => "adult",
    				'json' => json_encode($guestsList), 
    				'required' => 1,
    				'ranking' => 1
    			), 
    			array('%d', '%s', '%s', '%s', '%d')
    		);
    		
    		$guestsList = array(
    			0 => array("number" => 1, "price" => 0, "name" => "1 child"),
    			1 => array("number" => 2, "price" => 0, "name" => "2 children"),
    		);
    		$table_name = $wpdb->prefix."booking_package_guests";
    		$wpdb->insert(
    			$table_name, 
    			array(
    				'accountKey' => intval($accountKey), 
    				'name' => "Number of children", 
    				'target' => "children",
    				'json' => json_encode($guestsList), 
    				'required' => 0,
    				'ranking' => 2
    			), 
    			array('%d', '%s', '%s', '%s', '%d')
    		);
        	
        }
        
        public function getAccountScheduleData(){
        	
        	global $wpdb;
        	$accountKey = 1;
            if(isset($_POST['accountKey'])){
                
                $accountKey = $_POST['accountKey'];
                
            }
        	
        	$month = intval($_POST['month']);
        	$day = intval($_POST['day']);
        	$year = intval($_POST['year']);
        	
			$last_day = date('t', mktime(0, 0, 0, $month, $day, $year));
			$week_start_num = date('w', mktime(0, 0, 0, $month, $day, $year));
			$week_last_num = date('w', mktime(0, 0, 0, $month, $last_day, $year));
			
			$scheduleData = array();
			$jsonAraay = array('completeFlag' => 'accountScheduleData', 'startDay' => 1, 'lastDay' => intval($last_day), 'startWeek' => intval($week_start_num), 'lastWeek' => intval($week_last_num), 'month' => intval($month), 'year' => intval($year));
			$scheduleData['date'] = $jsonAraay;
			
			$calendarList = array();
			if(intval($week_start_num) != 0){
				
				$lastUnixTime = date('U', mktime(0, 0, 0, $month, 1, $year)) - 1;
				$lastYear = date('Y', $lastUnixTime);
				$lastMonth = date('m', $lastUnixTime);
				$endDay = intval(date('t', $lastUnixTime));
				$startDay = $endDay - intval(date('w', $lastUnixTime));
				$key = intval($lastYear.$lastMonth);
				$calendarList[$key] = array('startDay' => $startDay, 'lastDay' => $endDay, 'startWeek' => intval(date('w', mktime(0, 0, 0, $lastMonth, $startDay, $lastYear))), 'lastWeek' => intval(date('w', $lastUnixTime)), 'year' => $lastYear, 'month' => intval($lastMonth), 'day' => $startDay);
				
			}
			
			$calendarList[intval($year.sprintf('%02d', $month))] = $jsonAraay;
			
			if(intval($week_last_num) != 6){
				
				$lastUnixTime = date('U', mktime(23, 60, 0, $month, $last_day, $year));
				$lastYear = date('Y', $lastUnixTime);
				$lastMonth = date('m', $lastUnixTime);
				$endDay = 7 - intval(date('w', $lastUnixTime));
				$startDay = 1;
				$key = intval($lastYear.$lastMonth);
				$calendarList[$key] = array('startDay' => $startDay, 'lastDay' => $endDay, 'startWeek' => intval(date('w', $lastUnixTime)), 'lastWeek' => 6, 'year' => $lastYear, 'month' => intval($lastMonth), 'day' => $startDay);
				
			}
			
			$list = array();
			foreach($calendarList as $key => $value){
				
				for($i = $value['startDay']; $i <= $value['lastDay']; $i++){
					
					$key = $value['year'].sprintf("%02d%02d", $value['month'], $i);
					$dayArray = array('year' => $value['year'], 'month' => $value['month'], 'day' => $i, 'count' => null, 'accountKey' => $accountKey, 'status' => 0);
					$list[$key] = $dayArray;
					
				}
				
				$table_name = $wpdb->prefix."booking_package_schedule";
				$sql = $wpdb->prepare("SELECT year,month,day,accountKey,SUM(capacity),SUM(remainder),COUNT(day) FROM `".$table_name."` GROUP BY `year`,`month`,`day`,`holiday`,`accountKey` HAVING `accountKey` = %d AND `year` = %d AND `month` = %d AND (`day` >= %d AND `day` <= %d);", array(intval($accountKey), intval($value['year']), intval($value['month']), intval($value['startDay']), intval($value['lastDay'])));
				$calendarList[$key]['sql'] = $sql;
				$rows = $wpdb->get_results($sql, ARRAY_A);
				foreach($rows as $row){
					
					$key = $row['year'].sprintf("%02d%02d", $row['month'], $row['day']);
					if(isset($list[$key])){
						
						$list[$key]['status'] = 1;
						
					}
					
				}
				
			}
			
			$scheduleData['calendarList'] = $calendarList;
			$scheduleData['calendar'] = $list;
			
			/**
        	$list = array();
        	$table_name = $wpdb->prefix."booking_package_schedule";
			$sql = "SELECT year,month,day,accountKey,COUNT(*) FROM `".$table_name."` GROUP BY `year`,`month`,`day`,`accountKey` HAVING `accountKey` = %d AND `year` = %d AND `month` = %d;";
			$valueArray = array(intval($accountKey), intval($year), intval($month));
			
			$sql = $wpdb->prepare($sql, $valueArray);
			$rows = $wpdb->get_results($sql, ARRAY_A);
			foreach($rows as $row){
				
				$key = $row['year'].sprintf("%02d%02d", $row['month'], $row['day']);
				$jsonAraay = array('year' => $row['year'], 'month' => $row['month'], 'day' => $row['day'], 'count' => $row['COUNT(day)'], 'accountKey' => $row['accountKey']);
				$list[$key] = $jsonAraay;
				
			}
			
			$scheduleData['calendar'] = $list;
        	**/
        	
        	return $scheduleData;
        	
        }
        
        public function getRangeOfSchedule($accountKey = false){
        	
        	if($accountKey != false){
        		
        		global $wpdb;
        		$timezone = get_option('timezone_string');
				date_default_timezone_set($timezone);
				$account = $this->getCalendarAccount($accountKey);
            	$table_name = $wpdb->prefix."booking_package_schedule";
            	$scheduleList = array();
            	for($i = intval($_POST['start']); $i <= intval($_POST['end']); $i++){
            		
            		$date = date_parse($i);
            		if(!checkdate($date['month'], $date['day'], $date['year'])){
            			
            			$date = date_parse($i - 1);
            			$unixTime = date('U', mktime(23, 60, 0, $date['month'], $date['day'], $date['year'])) + 1;
            			$i = intval(date('Ymd', $unixTime));
            			$date = date_parse($i);
            			#var_dump($i);
            			#break;
            			
            		}
            		
            		$sql = $wpdb->prepare(
        				"SELECT * FROM ".$table_name." WHERE `accountKey` = %d AND `year` = %d AND `month` = %d AND `day` = %d ORDER BY day ASC;", 
        				array(
        					intval($accountKey), 
        					intval($date['year']), 
        					intval($date['month']), 
        					intval($date['day'])
        				)
        			);
        			$row = $wpdb->get_row($sql);
        			if(is_null($row)){
        				
        				$unixTime = date('U', mktime(0, 0, 0, intval($date['month']), $date['day'], intval($date['year'])));
        				$week = date('w', mktime(0, 0, 0, intval($date['month']), $date['day'], intval($date['year'])));
        				$scheduleList[$i] = array(
        					"accountKey" => $accountKey, 
        					"unixTime" => $unixTime,
        					"year" => intval($date['year']), 
        					"month" => intval($date['month']), 
        					"day" => $date['day'], 
        					"weekKey" => $week,
        					"hour" => 0,
        					"min" => 0,
        					"title" => "",
        					"stop" => "false",
        					"holiday" => "false",
        					"existence" => 0,
        					"waitingRemainder" => 0,
        					"uploadDate" => 0,
        					"cost" => $account['cost'],
        					"capacity" => $account['numberOfRoomsAvailable'],
        					"remainder" => $account['numberOfRoomsAvailable'],
        				);
        				
        			}else{
        				
        				$row->existence = 1;
        				$scheduleList[$i] = $row;
        				
        			}
        			
            	}
            	
            	return $scheduleList;
        		
        	}
        	
        	die();
        	
        }
        
        public function getPublicSchedule(){
        	
        	$accountKey = 1;
            if(isset($_POST['accountKey'])){
                
                $accountKey = $_POST['accountKey'];
                
            }
            
            $calendar = array();
            
        	global $wpdb;
            $table_name = $wpdb->prefix."booking_package_schedule";
			$sql = $wpdb->prepare("SELECT * FROM ".$table_name." WHERE `accountKey` = %d AND `year` = %d AND `month` = %d AND `day` = %d ORDER BY weekKey, hour, min ASC;", array(intval($accountKey), intval($_POST['year']), intval($_POST['month']), intval($_POST['day'])));
            $rows = $wpdb->get_results($sql, ARRAY_A);
            /**
            foreach($rows as $row){
            	
            	$key = $row['year'].sprintf("%02d%02d", $row['month'], $row['day']);
            	$calendar[$key] = $row;
            	
            }
            **/
            
            return $rows;
        	
        }
        
        public function getTemplateSchedule($weekKey){
        	
        	$accountKey = 1;
            if(isset($_POST['accountKey'])){
                
                $accountKey = $_POST['accountKey'];
                
            }
            
            global $wpdb;
            $table_name = $wpdb->prefix."booking_package_templateSchedule";
			$sql = $wpdb->prepare("SELECT * FROM ".$table_name." WHERE `accountKey` = %d AND `weekKey` = %d ORDER BY weekKey, hour, min ASC;", array(intval($accountKey), intval($weekKey)));
            $rows = $wpdb->get_results($sql, ARRAY_A);
            
            return $rows;
            
        }
        
        public function updateRangeOfSchedule($accountKey = false){
        	
        	if($accountKey != false && isset($_POST['json'])){
        		
        		global $wpdb;
        		$timezone = get_option('timezone_string');
				date_default_timezone_set($timezone);
				$updateDate = date('U');
				$account = $this->getCalendarAccount($accountKey);
            	$table_name = $wpdb->prefix."booking_package_schedule";
                    
				$jsonList = json_decode(str_replace("\\", "", $_POST['json']));
            	foreach($jsonList as $key => $value){
            		
            		
            		if($value->existence == 0){
            			
            			$sql = $wpdb->prepare(
        					"SELECT * FROM ".$table_name." WHERE `accountKey` = %d AND `year` = %d AND `month` = %d AND `day` = %d ORDER BY day ASC;", 
        					array(
        						intval($accountKey), 
        						intval($value->year), 
        						intval($value->month), 
        						intval($value->day)
        					)
        				);
        				$row = $wpdb->get_row($sql);
        				if(is_null($row)){
        					
        					/**
    						insertSchedule(	$table_name, $accountKey, $unixTime, $month, $day, $year, $week, $hour, $min, 
        					$title, $cost, $capacity, $stop, $uploadDate)
    						**/
    						
    						$this->insertSchedule(	$table_name, $accountKey, $value->unixTime, $value->month, $value->day,
    												$value->year, $value->weekKey, $value->hour, $value->min, $value->title,
    												$value->cost, $value->capacity, $value->stop, $updateDate);
    						
        				}
            			
            		}else{
            			
            			$sql = $wpdb->prepare(
        					"SELECT * FROM ".$table_name." WHERE `key` = %d;", 
        					array( 
        						intval($value->key)
        					)
        				);
        				$row = $wpdb->get_row($sql);
        				
        				if($row->capacity != $value->capacity){
        					
        					$value->remainder = $value->capacity - ($row->capacity - $row->remainder);
        					/**
        					if($row->capacity < $value->capacity){
	            				
	            				$value->remainder = $value->remainder + ($value->capacity - $row->capacity);
	            				
	        				}else{
	            				
	            				$value->remainder = $value->remainder - $value->capacity;
	            				
	        				}
        					**/
        				}
        				
        				$wpdb->update( 
        					$table_name,
							array(
								'cost' => intval($value->cost), 
								'capacity' => intval($value->capacity), 
								'remainder' => intval($value->remainder),
								'stop' => sanitize_text_field($value->stop)
							),
							array('key' => intval($value->key)),
							array('%d', '%d', '%d', '%s'),
							array('%d')
						);
            			
            		}
            		
            	}
            	
            	$_POST['accountKey'] = $accountKey;
            	$_POST['day'] = 1;
            	$response = array();
            	$response['getAccountScheduleData'] = $this->getAccountScheduleData();
            	$response['getRangeOfSchedule'] = $this->getRangeOfSchedule($accountKey);
            	
            	return $response;
            	
        	}
        	
        	die();
        	
        }
        
        public function updateAccountTemplateSchedule(){
        	
        	$accountKey = 1;
            if(isset($_POST['accountKey'])){
                
                $accountKey = $_POST['accountKey'];
                
            }
            
            global $wpdb;
            $array = array('completeFlag' => 'updateAccountTemplateSchedule');
	        $sqlList = array();
	        $valueList = array();
	        $updateTime = date('U');
	        
	        $scheduleRead = array();
		    $i = 0;
		    #$sql = "SELECT * FROM `booking_package_templateSchedule` WHERE `accountKey` = ? AND `weekKey` = ? ORDER BY hour, min ASC;";
		    
		    $table_name = $wpdb->prefix."booking_package_templateSchedule";
		    $valueArray = array(intval($accountKey), intval($_POST['weekKey']));
			$sql = $wpdb->prepare("SELECT * FROM ".$table_name." WHERE `accountKey` = %d AND `weekKey` = %d ORDER BY hour, min ASC;", array($valueArray));
            $rows = $wpdb->get_results($sql, ARRAY_A);
            if(is_null($rows) !== false){
                
                foreach($rows as $row){
                    
                    #var_dump($row);
                    $jsonArray = array(	'key' => $row['key'], 'weekKey' => $row['weekKey'], 'hour' => $row['hour'], 'min' => $row['min'], 
								'title' => $row['title'], 'cost' => $row['cost'], 'holiday' => $row['holiday']);
					$scheduleRead[$i] = $jsonArray;
					$i++;
                    
                }
                
            }
            
            for($i = 0; $i < $_POST['timeCount']; $i++){
			
				$unixTime = mktime(intval($_POST['hour'.$i]), intval($_POST['min'.$i]), 0, intval($_POST['month']), intval($_POST['day0']), intval($_POST['year']));
				$valueArray = array($accountKey, intval($_POST['hour'.$i]), intval($_POST['min'.$i]), intval($_POST['weekKey']));
				$table_name = $wpdb->prefix."booking_package_templateSchedule";
				$sql = $wpdb->prepare("SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND `hour` = %d AND `min` = %d AND `weekKey` = %d;", $valueArray);
				$row = $wpdb->get_row($sql, ARRAY_A);
				if(is_array($row)){
					
					#var_dump($row);
					if($_POST['delete'.$i] == 'true'){
						
						array_push($sqlList, "DELETE FROM `".$table_name."` WHERE `key` = %d;");
						array_push($valueList, array(intval($row['key'])));
						
					}else{
						
						$sql = "UPDATE ".$table_name." SET `hour` = %d, `min` = %d, `title` = %s, `cost` = %d, `capacity` = %d, `stop` = %s WHERE `key` = %d;";
						$value = array(	
							intval($_POST['hour'.$i]), 
							intval($_POST['min'.$i]), 
							sanitize_text_field($_POST['title'.$i]), 
							intval($_POST['cost'.$i]), 
							intval($_POST['capacity'.$i]), 
							sanitize_text_field($_POST['stop'.$i]), 
							intval($row['key'])
						);
						array_push($sqlList, $sql);
						array_push($valueList, $value);
						
					}
					
				}else{
					
					$sql = "INSERT INTO ".$table_name." (`accountKey`, `weekKey` ,`hour`, `min`, `title`, `cost`, `capacity`, `stop`, `holiday`, `uploadDate`) VALUES (%d, %d, %d, %d, %s, %d, %d, %s, %s, %d);";
					$value = array(
						intval($accountKey), 
						intval($_POST['weekKey']), 
						intval($_POST['hour'.$i]), 
						intval($_POST['min'.$i]), 
						sanitize_text_field($_POST['title'.$i]), 
						intval($_POST['cost'.$i]), 
						intval($_POST['capacity'.$i]), 
						sanitize_text_field($_POST['stop'.$i]), 
						'false', 
						$updateTime
					);
					array_push($sqlList, $sql);
					array_push($valueList, $value);
					
				}
				
				
				
			}
			
			$array['sql'] = $sqlList;
			$array['value'] = $valueList;
			
			for($i = 0; $i < count($sqlList); $i++){
				
				$sql = $wpdb->prepare($sqlList[$i], $valueList[$i]);
				$wpdb->query($sql);
				
			}
			
			$year = date('Y');
			$month = date('m');
			$day = date('d');
			$this->insertAccountSchedule($month, $day, $year);
            
        }
        
        public function insertSchedule(	$table_name, $accountKey, $unixTime, $month, $day, $year, $week, $hour, $min, 
        								$title, $cost, $capacity, $stop, $uploadDate){
        	
        	global $wpdb;
        	$wpdb->insert(
    			$table_name, 
    			array(
    				'accountKey' => intval($accountKey), 
    				'unixTime' => intval($unixTime), 
    				'year' => intval($year), 
    				'month' => intval($month), 
    				'day' => intval($day), 
    				'weekKey' => intval($week), 
    				'hour' => intval($hour), 
    				'min' => intval($min), 
    				'title' => sanitize_text_field($title), 
    				'cost' => intval($cost), 
    				'capacity' => intval($capacity), 
    				'remainder' => intval($capacity), 
    				'stop' => sanitize_text_field($stop), 
    				'holiday' => 'false', 
    				'uploadDate' => intval($uploadDate)
    			), 
    			array('%d', '%d', '%d', '%d', '%d', '%d', '%d', '%d', '%s', '%d', '%d', '%d', '%s', '%s', '%d')
    		);
        	
        	
        }
        
        public function insertAccountSchedule($month, $day, $year){
    		
    		global $wpdb;
    		$uploadDate = date('U');
    		$const_unixTime = date('U', mktime(0, 0, 0, $month, $day, $year));
    		$maxAccountScheduleDay = intval(get_option($this->prefix.'maxAccountScheduleDay', 7));
    		#var_dump($maxAccountScheduleDay);
    		
    		$table_name = $wpdb->prefix."booking_package_calendarAccount";
			$sql = $wpdb->prepare("SELECT * FROM `".$table_name."` WHERE `status` = %s;", array("open"));
			$rows = $wpdb->get_results($sql, ARRAY_A);
			foreach($rows as $row){
				
				$accountKey = $row['key'];
				$accountType = $row['type'];
				$calendarAccount = $row;
				$unixTime = $const_unixTime;
				for($i = 0; $i < $maxAccountScheduleDay; $i++){
    				
    				$year = date('Y', $unixTime);
					$month = date('m', $unixTime);
					$day = date('d', $unixTime);
					$week = date('w', $unixTime);
					#print $year."_".$month."_".$day."<br>\n";
					$unixTime += 1440 * 60;
					
					
					
					$table_name = $wpdb->prefix."booking_package_schedule";
					$sql = "SELECT `key` FROM `".$table_name."` WHERE `accountKey` = %d AND `year` = %d AND `month` = %d AND `day` = %d LIMIT 0, 1;";
    				$valueArray = array(intval($accountKey), intval($year), intval($month), intval($day));
    				$row = $wpdb->get_row($wpdb->prepare($sql, $valueArray));
    				
    				if(is_null($row)){
    					
    					if($calendarAccount['type'] == 'day'){
    						
    						$table_name = $wpdb->prefix."booking_package_templateSchedule";
    						$sql = "SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND `weekKey` = %d ORDER BY `weekKey`, `hour`, `min` ASC;";
    						$template_rows = $wpdb->get_results($wpdb->prepare($sql, array(intval($accountKey), intval($week))), ARRAY_A);
    						foreach($template_rows as $template_row){
    							
    							$time = date('U', mktime($template_row['hour'], $template_row['min'], 0, $month, $day, $year));
    							$table_name = $wpdb->prefix."booking_package_schedule";
    							
    							$this->insertSchedule(
    								$table_name, $accountKey, $time, $month, $day, $year, $week, 
    								$template_row['hour'], $template_row['min'], $template_row['title'],
    								$template_row['cost'], $template_row['capacity'], $template_row['stop'],
    								$uploadDate
    							);
    							
    						}
    						
    					}else{
    						
    						#$table_name = $wpdb->prefix."booking_package_schedule";
							#$sql = $wpdb->prepare("SELECT `unixTime` FROM `".$table_name."` WHERE `accountKey` = %d AND `unixTime` >= %d;", array(intval($accountKey), intval($const_unixTime)));
    						#$scheduleList = $wpdb->get_results($sql, OBJECT_K);
    						
    						#numberOfRoomsAvailable
    						$capacity = $calendarAccount['numberOfRoomsAvailable'];
    						$time = date('U', mktime(0, 0, 0, $month, $day, $year));
    						$table_name = $wpdb->prefix."booking_package_schedule";
    						
    						$wpdb->insert(
    							$table_name, 
    							array(
    								'accountKey' => intval($accountKey), 
    								'unixTime' => intval($time), 
    								'year' => intval($year), 
    								'month' => intval($month), 
    								'day' => intval($day), 
    								'weekKey' => intval($week), 
    								'hour' => 0, 
    								'min' => 0, 
    								'title' => '', 
    								'cost' => intval($calendarAccount['cost']), 
    								'capacity' => intval($capacity), 
    								'remainder' => intval($capacity), 
    								'stop' => 'false', 
    								'holiday' => 'false', 
    								'uploadDate' => $uploadDate
    							), 
    							array('%d', '%d', '%d', '%d', '%d', '%d', '%d', '%d', '%s', '%d', '%d', '%d', '%s', '%s', '%d')
    						);
    						
    					}
    					
    					
    					
    				}
    				
    			}
				
			}
    		
    		/**
    		for($i = 0; $i < $maxAccountScheduleDay; $i++){
    			
    			$year = date('Y', $unixTime);
				$month = date('m', $unixTime);
				$day = date('d', $unixTime);
				$week = date('w', $unixTime);
				#print $year."_".$month."_".$day."<br>\n";
				$unixTime += 1440 * 60;
				
				$table_name = $wpdb->prefix."booking_package_schedule";
				$sql = "SELECT `key` FROM `".$table_name."` WHERE `accountKey` = %d AND `year` = %d AND `month` = %d AND `day` = %d LIMIT 0, 1;";
    			$valueArray = array(1, intval($year), intval($month), intval($day));
    			#$sql = $wpdb->prepare($sql, $valueArray);
    			$row = $wpdb->get_row($wpdb->prepare($sql, $valueArray));
    			
    			if(is_null($row)){
    				
    				$table_name = $wpdb->prefix."booking_package_templateSchedule";
    				$sql = "SELECT * FROM `".$table_name."` WHERE `weekKey` = %d ORDER BY `weekKey`, `hour`, `min` ASC;";
    				$rows = $wpdb->get_results($wpdb->prepare($sql, array(intval($week))), ARRAY_A);
    				foreach($rows as $row){
    					
    					$time = date('U', mktime($row['hour'], $row['min'], 0, $month, $day, $year));
    					$table_name = $wpdb->prefix."booking_package_schedule";
    					
    					$wpdb->insert(
    						$table_name, 
    						array(
    							'accountKey' => 1, 
    							'unixTime' => intval($time), 
    							'year' => intval($year), 
    							'month' => intval($month), 
    							'day' => intval($day), 
    							'weekKey' => intval($week), 
    							'hour' => intval($row['hour']), 
    							'min' => intval($row['min']), 
    							'title' => $row['title'], 
    							'cost' => intval($row['cost']), 
    							'capacity' => intval($row['capacity']), 
    							'remainder' => intval($row['capacity']), 
    							'stop' => $row['stop'], 
    							'holiday' => 'false', 
    							'uploadDate' => $uploadDate
    						), 
    						array('%d', '%d', '%d', '%d', '%d', '%d', '%d', '%d', '%s', '%d', '%d', '%d', '%s', '%s', '%d')
    					);
    					
    				}
    				
    				
    			}
    			
    		}
    		**/
    		
    		/**
    		$table_name = $wpdb->prefix."booking_package_schedule";
			$sql = "SELECT year,month,day,accountKey,COUNT(*) FROM `".$table_name."` GROUP BY `year`,`month`,`day`,`accountKey` HAVING `accountKey` = %d AND `year` = %d AND `month` = %d;";
			$valueArray = array(1, intval($_POST['year']), intval($_POST['month']));
			
			$sql = $wpdb->prepare($sql, $valueArray);
			$rows = $wpdb->get_results($sql, ARRAY_A);
    		**/
    		
    	}
    	
    	public function updateAccountSchedule(){
    		
    		$accountKey = 1;
            if(isset($_POST['accountKey'])){
                
                $accountKey = $_POST['accountKey'];
                
            }
    		
    		global $wpdb;
    		$sql = '';
    		$courseTime = 0;
    		$maintenanceTime = 0;
    		
			$array = array();
			$value_array = array();
			$rpeatList = array();
			$prepareForRpeatReservation = array();
			
			$table_name = $wpdb->prefix."booking_package_courseData";
			$sql = "SELECT `key`,max(`time`) FROM `".$table_name."` WHERE `accountKey` = %d;";
    		$row = $wpdb->get_row($wpdb->prepare($sql, array(intval($accountKey))), ARRAY_A);
    		if(is_null($row)){
    			
    			$courseTime = 0;
    			
    		}else{
    			
    			$courseTime = intval($row["max(`time`)"]);
    			
    		}
    		
    		for($i = 0; $i < $_POST['timeCount']; $i++){
    			
    			$updateBool = false;
    			$unixTime = intval(date('U', mktime($_POST['hour'.$i], $_POST['min'.$i], 0, $_POST['month'], $_POST['day'], $_POST['year'])));
    			$weekKey = intval(date('w', mktime($_POST['hour'.$i], $_POST['min'.$i], 0, $_POST['month'], $_POST['day'], $_POST['year'])));
    			
    			if($_POST['key'.$i]){
    				
    				$table_name = $wpdb->prefix."booking_package_schedule";
    				$sql = "SELECT * FROM `".$table_name."` WHERE `key` = %d;";
    				$row = $wpdb->get_row($wpdb->prepare($sql, array(intval($_POST['key'.$i]))), ARRAY_A);
    				if(!is_null($row)){
    					
    					#var_dump($row);
    					$updateBool = true;
    					if($_POST['delete'.$i] == 'true'){
    						
    						$sql = "DELETE FROM `".$table_name."` WHERE `key` = %d;";
    						$updateArray = array(intval($_POST['key'.$i]));
    						
    					}else{
    						
							$capacity = $_POST['capacity'.$i];
							$remainder = $_POST['remainder'.$i];
    						
    						$sql = "UPDATE `".$table_name."` SET `unixTime` = %d, `year` = %d, `month` = %d, `day` = %d, ";
							$sql .= "`hour` = %d, `min` = %d, `title` = %s, `capacity` = %d, `remainder` = %d, `stop` = %s, `cost` = %d ";
							$sql .= "WHERE `key` = %d;";
    						$updateArray = array(
    												$unixTime,
    												intval($_POST['year']),
    												intval($_POST['month']),
    												intval($_POST['day']),
    												intval($_POST['hour'.$i]),
    												intval($_POST['min'.$i]),
    												sanitize_text_field($_POST['title'.$i]),
													intval($capacity),
													intval($remainder),
													sanitize_text_field($_POST['stop'.$i]),
													intval(0),
													intval($_POST['key'.$i])
												);
							
    					}
    					
    				}
    				
    			}else{
    				
    				$remainder = $_POST['capacity'.$i];
    				$remainder = $_POST['remainder'.$i];
    				$reserveRemainder = 0;
    				
    				$table_name = $wpdb->prefix."booking_package_userPraivateData";
    				$serch_sql = "SELECT * FROM `".$table_name."` WHERE `scheduleUnixTime` > %d AND `scheduleUnixTime` < %d AND `accountKey` = %d;";
					$valueArray = array(($unixTime - ($courseTime * 60) - ($maintenanceTime * 60)), $unixTime, array(intval($accountKey)));
    				#var_dump($valueArray);
    				$sql = $wpdb->prepare($serch_sql, $valueArray);
					$rows = $wpdb->get_results($sql, ARRAY_A);
					foreach($rows as $row){
						
						$reserveUnixTime = $row['scheduleUnixTime'] + ($row['courseTime'] * 60);
						if($unixTime < $reserveUnixTime){
							$remainder--;
							$reserveRemainder++;
						}
						
					}
					
					if($remainder < 0){
						
						$updateBool = false;
						
					}else{
						
						$updateBool = true;
						
					}
					
					if($updateBool == true){
						
						$table_name = $wpdb->prefix."booking_package_schedule";
						$sql = "SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND `unixTime` = %d;";
						$row = $wpdb->get_row($wpdb->prepare($sql, array(intval($accountKey), $unixTime)), ARRAY_A);
						if(is_null($row)){
							
							$sql = "INSERT INTO `".$table_name."` (`accountKey`,`unixTime`,`year`,`month`,`day`, `weekKey`, `hour`,`min`,`title`,`capacity`,`remainder`,`stop`,`holiday`,`cost`) ";
							$sql .= "VALUES (%d, %d, %d, %d, %d, %d, %d, %d, %s, %d, %d, %s, %s, %d);";
							$updateArray = array(
								intval($accountKey),
								$unixTime,
								intval($_POST['year']),
								intval($_POST['month']),
								intval($_POST['day']),
								intval($weekKey),
								intval($_POST['hour'.$i]),
								intval($_POST['min'.$i]),
								sanitize_text_field($_POST['title'.$i]),
								intval($_POST['capacity'.$i]),
								intval($remainder),
								sanitize_text_field($_POST['stop'.$i]),
								"false",
								intval(0)
							);
							
						}
						
					}
    				
    				
    			}
    			
    			if($updateBool == true){
					#var_dump($sql);
					array_push($array, $sql);
					array_push($value_array, $updateArray);
				}
				
				
    			
    		}
    		
    		for($i = 0; $i < count($array); $i++){
					
				$sql = $wpdb->prepare($array[$i], $value_array[$i]);
				#var_dump($sql);
				$wpdb->query($sql);
				
			}
    		
    	}
    	
    	public function deleteOldDaysInSchedules(){
    		
    		global $wpdb;
    		$timezone = get_option('timezone_string');
            date_default_timezone_set($timezone);
            $unixTime = date('U') - (14 * 24 * 3600);
            $unixTime = date('U', mktime(0, 0, 0, date('m', $unixTime), date('d', $unixTime), date('Y', $unixTime)));
            
            $table_name = $wpdb->prefix."booking_package_schedule";
            $sql = $wpdb->prepare("DELETE FROM `".$table_name."` WHERE `unixTime` < %d;", array($unixTime));
            $wpdb->query($sql);
            return $sql;
    		
    	}
    	
    	public function getReservationUsersData($month, $day, $year){
    		
    		$start = date('U', mktime(0, 0, 0, $month, $day, $year));
    		$end = date('U', mktime(23, 59, 59, $month, $day, $year));
    		
    		$response = array();
    		global $wpdb;
    		$table_name = $wpdb->prefix."booking_package_userPraivateData";
			$sql = $wpdb->prepare("SELECT `key`,`accountKey`,`status`,`scheduleUnixTime`,`courseName`,`praivateData`,`accommodationDetails` FROM `".$table_name."` WHERE `scheduleUnixTime` >= %d AND `scheduleUnixTime` <= %d ORDER BY `scheduleUnixTime` ASC;", array(intval($start), intval($end)));
			$rows = $wpdb->get_results($sql, ARRAY_A);
			foreach($rows as $row){
				
				if(!isset($response[$row['accountKey']])){
					
					$response[$row['accountKey']] = array();
					
				}
				
				$row['praivateData'] = json_decode($row['praivateData'], true);
				$row['accommodationDetails'] = json_decode($row['accommodationDetails'], true);
				array_push($response[$row['accountKey']], $row);
				
			}
			
			return $response;
			
    	}
    	
    	public function getReservationData($month, $day, $year, $ical = false, $public = false){
    		
    		$accountKey = 1;
    		if(isset($_POST['accountKey'])){
    			
    			$accountKey = $_POST['accountKey'];
    			
    		}
    		
    		global $wpdb;
    		$account = $this->getCalendarAccount($accountKey);
    		$reserveData = array();
    		
    		if($ical === false){
    			
    			if(is_null($month) && is_null($day) !== true && is_null($year)){
    				
    				$month = date('m');
    				$day = date('d');
    				$year = date('Y');
    				
    			}
    			
    			if($month != date('m') || $year != date('Y')){
    				
    				$day = 1;
    				
    			}else{
    				
    				$day = date('d');
    				
    			}
    			
    			if($public !== false){
    				
    				$unavailableDaysFromToday = get_option($this->prefix."unavailableDaysFromToday", 0) * (1440 * 60);
    				$unixTime = date('U') + $unavailableDaysFromToday;
    				
    				if(date('U', mktime(0, 0, 0, $month, 1, $year)) < $unixTime){
    					
    					$month = date('m', $unixTime);
    					$day = date('d', $unixTime);
    					$year = date('Y', $unixTime);
    					
    				}
    				
    				#$reserveData['test'] = array('month' => $month, 'day' => $day, 'year' => $year, 'unixTime' => $unixTime);
    				
    			}
    			
    		}else{
    			
    			
    			
    		}
    		
    		
    		#print "$month / $day / $year";
    		$last_day = date('t', mktime(0, 0, 0, $month, $day, $year));
			$week_start_num = intval(date('w', mktime(0, 0, 0, $month, 1, $year)));
			$week_last_num = intval(date('w', mktime(0, 0, 0, $month, $last_day, $year)));
			
			
			
			if($ical === false){
				
				$arrayValue = array('startDay' => 1, 'lastDay' => $last_day, 'startWeek' => $week_start_num, 'lastWeek' => $week_last_num, 'year' => $year, 'month' => intval($month), 'day' => 1);
				$reserveData['date'] = $arrayValue;
				
				$calendarList = array();
				if(intval($week_start_num) != 0){
					
					$lastUnixTime = date('U', mktime(0, 0, 0, $month, 1, $year)) - 1;
					$lastYear = date('Y', $lastUnixTime);
					$lastMonth = date('m', $lastUnixTime);
					$endDay = intval(date('t', $lastUnixTime));
					$startDay = $endDay - intval(date('w', $lastUnixTime));
					$key = intval($lastYear.$lastMonth);
					$calendarList[$key] = array('startDay' => $startDay, 'lastDay' => $endDay, 'startWeek' => intval(date('w', mktime(0, 0, 0, $lastMonth, $startDay, $lastYear))), 'lastWeek' => intval(date('w', $lastUnixTime)), 'year' => $lastYear, 'month' => intval($lastMonth), 'day' => $startDay);
					
				}
				
				$calendarList[intval($year.sprintf('%02d', $month))] = $arrayValue;
				
				if(intval($week_last_num) != 6){
					
					$lastUnixTime = date('U', mktime(23, 60, 0, $month, $last_day, $year));
					$lastYear = date('Y', $lastUnixTime);
					$lastMonth = date('m', $lastUnixTime);
					$endDay = 7 - intval(date('w', $lastUnixTime));
					$startDay = 1;
					$key = intval($lastYear.$lastMonth);
					$calendarList[$key] = array(
						'startDay' => $startDay, 
						'lastDay' => $endDay, 
						'startWeek' => intval(date('w', $lastUnixTime)), 
						'lastWeek' => 6, 
						'year' => $lastYear, 
						'month' => intval($lastMonth), 
						'day' => $startDay);
					
				}
				
				
				$reserveData['calendarList'] = $calendarList;
				$days = array();
				$reservation = array();
				$reservationForHotel = array();
				$schedule = array();
				$schedule_start_day = null;
				if($public !== false && $month == date('n')){
					
					#$schedule_start_day = $day;
					$schedule_start_day = intval(date('Ymd', mktime(0, 0, 0, $month, $day, $year)));
					
				}
				
				$visitorList = array();
				$number = 0;
				foreach($calendarList as $key => $value){
					
					for($i = $value['startDay']; $i <= $value['lastDay']; $i++){
						
						$calendarUnixTime = date('U', mktime(0, 0, 0, $value['month'], $i, $value['year']));
						$week = date('w', mktime(0, 0, 0, $value['month'], $i, $value['year']));
    					$scheduleKey = $value['year'].sprintf("%02d%02d", $value['month'], $i);
    					$arrayValue = array('number' => $number, 'year' => $value['year'], 'month' => $value['month'], 'day' => $i, 'week' => $week, 'select' => 'false');
    					$number++;
    					$days[$scheduleKey] = $arrayValue;
    					
    					$table_name = $wpdb->prefix."booking_package_schedule";
						$sql = $wpdb->prepare("SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND `year` = %d AND `month` = %d AND `day` = %d AND `holiday` = 'false' ORDER BY `unixTime` ASC;", array(intval($accountKey), intval($value['year']), intval($value['month']), intval($i)));
						$rows = $wpdb->get_results($sql, ARRAY_A);
						$key = intval($value['year'].sprintf("%02d%02d", $value['month'], $i));
						$schedule[$key] = $rows;
						
						if(count($rows) == 0 && $account->type == "hotel"){
							
							$schedule[$key] = array('unixTime' => date('U', mktime(0, 0, 0, $value['month'], $i, $value['year'])), "remainder" => 0);
							
						}
						
						if(!is_null($schedule_start_day) && intval(date('Ymd', mktime(0, 0, 0, $value['month'], $i, $value['year']))) < $schedule_start_day){
							
							$schedule[$key] = array();
							
						}
						
						if($public == false){
							
							$startUnixTime = date('U', mktime(0, 0, 0, $value['month'], $i, $value['year']));
							$stopUnixTime = $startUnixTime + (1440 * 60);
							$table_name = $wpdb->prefix."booking_package_userPraivateData";
							$sql = $wpdb->prepare("SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND `scheduleUnixTime` >= %d AND `scheduleUnixTime` < %d ORDER BY `scheduleUnixTime` ASC;", array(intval($accountKey), $startUnixTime, $stopUnixTime));
							if($account['type'] == 'hotel'){
								
								$sql = $wpdb->prepare("SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND `checkOut` >= %d AND `checkIn` < %d ORDER BY `scheduleUnixTime` ASC;", array(intval($accountKey), $startUnixTime, $stopUnixTime));
								
							}
							$rows = $wpdb->get_results($sql, ARRAY_A);
							if(is_null($rows) === false && count($rows) != 0){
								
								$deleteList = array();
								for($row = 0; $row < count($rows); $row++){
									
									if(!isset($visitorList[$rows[$row]['key']])){
										
										$visitorList[$rows[$row]['key']] = 1;
										
									}else{
										
										$visitorList[$rows[$row]['key']]++;
										array_push($deleteList, $row);
										
									}
									
									$json = json_decode($rows[$row]['praivateData']);
									$rows[$row]['praivateData'] = $json;
									$unixTime = $rows[$row]['scheduleUnixTime'];
									$rows[$row]['date'] = array(
										'month' => date('n', $unixTime), 
										'day' => date('d', $unixTime), 
										'year' => date('Y', $unixTime), 
										'week' => date('w', $unixTime), 
										'hour' => date('H', $unixTime), 
										'min' => date('i', $unixTime), 
										'timeZone' => date('e', $unixTime), 
										'checkIn' => 0, 
										'checkOut' => 0
									);
									
									if($account['type'] == "hotel"){
										
										$rows[$row]['date']['checkIn'] = date('Ymd', $rows[$row]['checkIn']);
										$rows[$row]['date']['checkOut'] = date('Ymd', $rows[$row]['checkOut']);
										$rows[$row]['date']['checkIn_month'] = date('n', $rows[$row]['checkIn']);
										$rows[$row]['date']['checkIn_day'] = date('j', $rows[$row]['checkIn']);
										$rows[$row]['date']['checkIn_year'] = date('Y', $rows[$row]['checkIn']);
										$rows[$row]['date']['checkIn_week'] = date('w', $rows[$row]['checkIn']);
										$rows[$row]['date']['checkOut_month'] = date('n', $rows[$row]['checkOut']);
										$rows[$row]['date']['checkOut_day'] = date('j', $rows[$row]['checkOut']);
										$rows[$row]['date']['checkOut_year'] = date('Y', $rows[$row]['checkOut']);
										$rows[$row]['date']['checkOut_week'] = date('w', $rows[$row]['checkOut']);
										
										$rows[$row]['accommodationDetails'] = json_decode($rows[$row]['accommodationDetails']);
										
										#$reservationForHotel
										$time = intval($rows[$row]['checkIn']);
										#var_dump($time);
										while($time <= intval($rows[$row]['checkOut'])){
											
											#var_dump($time);
											$dateKey = date('Ymd', $time);
											if(!isset($reservationForHotel[$dateKey])){
												
												$reservationForHotel[$dateKey] = array();
												
											}
											
											$reservationForHotel[$dateKey][$rows[$row]['key']] = $rows[$row];
											
											$time += 1440 * 60;
											
										}
										
									}
									/**
									if($account['type'] == 'hotel' && $visitorList[$rows[$row]['key']] > 1 && intval($calendarUnixTime) != intval($rows[$row]['checkIn'])){
										
										#unset($rows[$row]);
										
									}
									**/
								}
								
								arsort($deleteList);
								for($deleteKey = 0; $deleteKey < count($deleteList); $deleteKey++){
									
									unset($rows[$deleteKey]);
									
								}
								
								if(count($rows) > 0){
									
									$reservation[$key] = $rows;
									
								}
								
							}
							
						}
						
					}
					
					$table_name = $wpdb->prefix."booking_package_schedule";
					$sql = $wpdb->prepare("SELECT year,month,day,accountKey,SUM(capacity),SUM(remainder),COUNT(day) FROM `".$table_name."` GROUP BY `year`,`month`,`day`,`holiday`,`accountKey` HAVING `accountKey` = %d AND `year` = %d AND `month` = %d AND `day` >= %d AND `holiday` = 'false';", array(intval($accountKey), intval($value['year']), intval($value['month']), intval($day)));
					#$reserveData['calendarList'][$key]['sql'] = $sql;
					
				}
				$reserveData['calendar'] = $days;
				$reserveData['schedule'] = $schedule;
				$reserveData['reservation'] = $reservation;
				$reserveData['reservationForHotel'] = $reservationForHotel;
				#$reserveData['visitorList'] = $visitorList;
				
				/**
    			$schedule = array();
    			for($i = 1; $i <= $last_day; $i++){
    				
    				$week = date('w', mktime(0, 0, 0, $month, $i, $year));
    				$key = $year.sprintf("%02d%02d", $month, $i);
    				$arrayValue = array('year' => $year, 'month' => $month, 'day' => $i, 'week' => $week, 'select' => 'false');
    				#$schedule[$i] = $arrayValue;
    				$schedule[$key] = $arrayValue;
    				
    			}
    			
    			
            	$table_name = $wpdb->prefix."booking_package_schedule";
				$sql = $wpdb->prepare("SELECT year,month,day,accountKey,SUM(capacity),SUM(remainder),COUNT(day) FROM `".$table_name."` GROUP BY `year`,`month`,`day`,`holiday`,`accountKey` HAVING `accountKey` = %d AND `year` = %d AND `month` = %d AND `day` >= %d AND `holiday` = 'false';", array(intval($accountKey), intval($year), intval($month), intval($day)));
				
				$rows = $wpdb->get_results($sql, ARRAY_A);
				foreach($rows as $row){
					
					$week = date('w', mktime(0, 0, 0, $row['month'], $row['day'], $row['year']));
					$p = floor(($row['SUM(remainder)'] / $row['SUM(capacity)']) * 100);
					$key = intval($row['year']).sprintf("%02d%02d", intval($row['month']), intval($row['day']));
					$arrayValue = array('year' => $row['year'], 'month' => $row['month'], 'day' => $row['day'], 'week' => $week, 'select' => 'true', 'count' => $row['COUNT(day)'], 'capacity' => $row['SUM(capacity)'], 'remainder' => $row['SUM(remainder)'], 'p' => $p);
					#$schedule[$row['day']] = $arrayValue;
					$schedule[$key] = $arrayValue;
					
				}
				
				$reserveData['calendar'] = $schedule;
				
				$reservation = array();
				$schedule = array();
				$schedule_start_day = null;
				if($public !== false){
					
					$schedule_start_day = $day;
					
				}
				for($i = 1; $i <= $last_day; $i++){
					
					$table_name = $wpdb->prefix."booking_package_schedule";
					$sql = $wpdb->prepare("SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND `year` = %d AND `month` = %d AND `day` = %d AND `holiday` = 'false';", array(intval($accountKey), intval($year), intval($month), intval($i)));
					$rows = $wpdb->get_results($sql, ARRAY_A);
					$key = intval($year.sprintf("%02d%02d", $month, $i));
					$schedule[$key] = $rows;
					
					if(count($rows) == 0 && $account->type == "hotel"){
						
						$schedule[$key] = array('unixTime' => date('U', mktime(0, 0, 0, $month, $i, $year)), "remainder" => 0);
						
					}
					
					if(!is_null($schedule_start_day) && $i < $schedule_start_day){
						
						$schedule[$key] = array();
						
					}
					
					if($public == false){
						
						$startUnixTime = date('U', mktime(0, 0, 0, $month, $i, $year));
						$stopUnixTime = $startUnixTime + (1440 * 60);
						$table_name = $wpdb->prefix."booking_package_userPraivateData";
						$sql = $wpdb->prepare("SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND `scheduleUnixTime` >= %d AND `scheduleUnixTime` < %d ORDER BY `scheduleUnixTime` ASC;", array(intval($accountKey), $startUnixTime, $stopUnixTime));
						$rows = $wpdb->get_results($sql, ARRAY_A);
						if(is_null($rows) === false && count($rows) != 0){
							
							for($row = 0; $row < count($rows); $row++){
								
								$json = json_decode($rows[$row]['praivateData']);
								$rows[$row]['praivateData'] = $json;
								$unixTime = $rows[$row]['scheduleUnixTime'];
								#$rows[$row]['date'] = array('month' => (date('n', $unixTime) - 1), 'day' => date('d', $unixTime), 'year' => date('Y', $unixTime), 'week' => date('w', $unixTime), 'hour' => date('H', $unixTime), 'min' => date('i', $unixTime), 'timeZone' => date('e', $unixTime));
								$rows[$row]['date'] = array('month' => date('n', $unixTime), 'day' => date('d', $unixTime), 'year' => date('Y', $unixTime), 'week' => date('w', $unixTime), 'hour' => date('H', $unixTime), 'min' => date('i', $unixTime), 'timeZone' => date('e', $unixTime));
								
							}
							
							$reservation[$key] = $rows;
							
						}
						
					}
					
					
				}
				$reserveData['schedule'] = $schedule;
				$reserveData['reservation'] = $reservation;
				**/
				
				if($public == false && $account->type == "hotel"){
					
					
					
				}
				
			}else{
				
				$table_name = $wpdb->prefix."booking_package_userPraivateData";
				$sql = $wpdb->prepare("SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND `scheduleUnixTime` >= %d ORDER BY `scheduleUnixTime` ASC;", array(intval($accountKey), $startUnixTime));
				$rows = $wpdb->get_results($sql, ARRAY_A);
				#var_dump($rows);
				if(is_null($rows) === false && count($rows) != 0){
						
					for($row = 0; $row < count($rows); $row++){
						
						$json = json_decode($rows[$row]['praivateData']);
						$rows[$row]['praivateData'] = $json;
						$unixTime = $rows[$row]['scheduleUnixTime'];
						$rows[$row]['date'] = array('unixTime' => $unixTime, 'month' => date('m', $unixTime), 'day' => date('d', $unixTime), 'year' => date('Y', $unixTime), 'week' => date('w', $unixTime), 'hour' => date('H', $unixTime), 'min' => date('i', $unixTime), 'timeZone' => date('e', $unixTime));
						
					}
					
					$reserveData = $rows;
					
				}
				
			}
    		
			return $reserveData;
			
    	}
    	
    	public function getDownloadCSV(){
    		
    		global $wpdb;
    		$response = array("status" => "success", "csv" => null);
    		$visitorsList = array();
    		$csv = '';
    		$calendarAccount = $this->getCalendarAccount($_POST['accountKey']);
    		$currency = get_option($this->prefix."currency", 'usd');
    		$dateFormat = intval(get_option($this->prefix."dateFormat", 0));
    		$positionOfWeek = get_option($this->prefix."positionOfWeek", "before");
    		
    		$table_name = $wpdb->prefix."booking_package_userPraivateData";
    		$startUnixTime = 0;
    		$stopUnixTime = 0;
    		if(isset($_POST['day']) && $_POST['day'] != ''){
    			
    			$startUnixTime = date('U', mktime(0, 0, 0, intval($_POST['month']), intval($_POST['day']), intval($_POST['year'])));
    			$stopUnixTime = date('U', mktime(23, 59, 59, intval($_POST['month']), intval($_POST['day']), intval($_POST['year'])));
    			
    		}else{
    			
    			$lastDay = date('t', mktime(0, 0, 0, intval($_POST['month']), 1, intval($_POST['year'])));
    			$startUnixTime = date('U', mktime(0, 0, 0, intval($_POST['month']), 1, intval($_POST['year'])));
    			$stopUnixTime = date('U', mktime(23, 59, 59, intval($_POST['month']), intval($lastDay), intval($_POST['year'])));
    			
    		}
			$sql = $wpdb->prepare("SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND `scheduleUnixTime` >= %d AND `scheduleUnixTime` < %d ORDER BY `key` ASC;", array(intval($_POST['accountKey']), $startUnixTime, $stopUnixTime));
			$response['sql'] = $sql;
			$rows = $wpdb->get_results($sql, ARRAY_A);
			foreach($rows as $row){
				
				$visitor = array(
					"key" => $row['key'],
					"status" => $row['status'],
				);
				
				if($calendarAccount['type'] == 'day'){
					
					$visitor['scheduleDate'] = $this->dateFormat($dateFormat, $positionOfWeek, $row['scheduleUnixTime'], $row['title'], true, false);
					
				}else{
					
					$visitor['checkIn'] = $this->dateFormat($dateFormat, $positionOfWeek, $row['checkIn'], null, false, false);
					$visitor['checkOut'] = $this->dateFormat($dateFormat, $positionOfWeek, $row['checkOut'], null, false, false);
					
				}
				
				$praivateData = json_decode($row['praivateData'], true);
				for($i = 0; $i < count($praivateData); $i++){
					
					$id = "form_".$praivateData[$i]['id'];
					$visitor[$id] = $praivateData[$i]['value'];
					
				}
				
				array_push($visitorsList, $visitor);
				$csv .= implode(",", $visitor)."\r\n";
				
			}
			$response['rows'] = $rows;
			$response['visitorsList'] = $visitorsList;
    		$response['calendarAccount'] = $calendarAccount;
    		$response['csv'] = $csv;
    		return $response;
    		
    	}
    	
    	public function serachCourse($accountKey, $key = false, $time = false){
    		
    		global $wpdb;
    		$table_name = $wpdb->prefix."booking_package_courseData";
    		if($key !== false){
    			
    			$sql = $wpdb->prepare("SELECT `key`,`name`,`time`,`cost` FROM `".$table_name."` WHERE `accountKey` = %d AND `key` = %d LIMIT 0, 1;", array(intval($accountKey), intval($key)));
    			
    		}
    		
    		if($time != false){
    			
    			$sql = $wpdb->prepare("SELECT `key`,`name`,`time`,`cost` FROM `".$table_name."` WHERE `accountKey` = %d AND `time` = %d LIMIT 0, 1;", array(intval($accountKey), intval($time)));
    			
    		}
    		$row = $wpdb->get_row($sql, ARRAY_A);
    		if(is_null($row)){
    			
    			return array('status' => 'error');
    			
    		}else{
    			
    			return $row;
    			
    		}
    		
    	}
    	
    	public function getStatus($userDetail = false){
    		
    		#$this->automaticApprove = boolval(intval(get_option($this->prefix."automaticApprove", 0)));
    		$this->automaticApprove = intval(get_option($this->prefix."automaticApprove", 0));
    		if($this->automaticApprove == 0){
	    		
	    		$this->automaticApprove = false;
	    		
    		}else {
	    		
	    		$this->automaticApprove = true;
	    		
    		}
    		$status = "pending";
    		if($userDetail !== false){
    			
    			if(isset($userDetail['status'])){
    				
    				return $userDetail['status'];
    				
    			}else{
    				
    				if($this->automaticApprove === true){
    					
    					$status = "approved";
    					
    				}
    				
    			}
    			
    		}else{
    			
    			if($this->automaticApprove === true){
    				
    				$status = "approved";
    				
    			}
    			
    		}
    		
    		return $status;
    		
    	}
    	
    	public function serachSchedule($unixTime, $accountKey = 1){
    		
    		global $wpdb;
    		$table_name = $wpdb->prefix."booking_package_schedule";
    		$sql = $wpdb->prepare("SELECT `key`,`unixTime`,`title`,`capacity`,`remainder`,`stop` FROM `".$table_name."` WHERE `accountKey` = %d AND `unixTime` = %d LIMIT 0, 1;", array(intval($accountKey), intval($unixTime)));
    		$row = $wpdb->get_row($sql, ARRAY_A);
    		if(is_null($row)){
    			
    			return array('status' => 'error');
    			
    		}else{
    			
    			return $row;
    			
    		}
    		
    	}
    	
    	public function createAccommodationDetails($calendarAccount, $json, $sql_start_unixTime, $applicantCount, $accommodationDetails = null){
    		
    		global $wpdb;
    		
    		$accountKey = $calendarAccount['key'];
    		$nights = 0;
    		$totalCost = 0;
    		if(is_null($accommodationDetails)){
    			
    			$accommodationDetails = array("scheduleList" => array(), "guestsList" => array(), 'type' => $calendarAccount['type']);
    			
    		}else{
    			
    			$unixTimeEnd = $accommodationDetails['checkOut'];
				$nights = $accommodationDetails['nights'];
				$additionalFee = $accommodationDetails['additionalFee'];
    			$totalCost = $accommodationDetails['accommodationFee'];
    				
    		}
    		
    		if(is_array($json)){
    			
    			$jsonList = $json;
    			
    		}else{
    			
    			$jsonList = json_decode(str_replace("\\", "", $json), true);
    			
    		}
    		
    		
    		
    		$scheduleList = array_values($jsonList['list']);
    		$first = null;
    		$last = null;
    		if(count($scheduleList) != 0){
    			
    			$nights = 0;
    			$totalCost = 0;
    			$first = reset($scheduleList);
    			$last = end($scheduleList);
    			$table_name = $wpdb->prefix."booking_package_schedule";
    			$sql = $wpdb->prepare("SELECT `key`,`month`,`day`,`year`,`weekKey`,`unixTime`,`cost`,`remainder` FROM `".$table_name."` WHERE `accountKey` = %d AND (`unixTime` >= %d AND `unixTime` <= %d) ORDER BY `unixTime` ASC;", array(intval($accountKey), intval($first['unixTime']), intval($last['unixTime'])));
    			$rows = $wpdb->get_results($sql, ARRAY_A);
    			if(count($rows) != 0 && !is_null($rows)){
    				
    				$accommodationDetails['scheduleList'] = array();
    				$accommodationDetails['scheduleDetails'] = array();
    				$unixTimeList = array();
    				$i = 0;
    				foreach($rows as $row){
            			
            			array_push($accommodationDetails['scheduleList'], $row['key']);
            			$accommodationDetails['scheduleDetails'][$row['unixTime']] = $row;
            			/**
            			if(array_search($row['key'], $accommodationDetails['scheduleList']) == false){
            				
            				array_push($accommodationDetails['scheduleList'], $row['key']);
            				
            			}
            			**/
            			
            			$date = $this->dateFormat($dateFormat, $positionOfWeek, $row['unixTime'], $row['title'], false, false);
            			if($row['remainder'] <= 0){
            				
            				return array("status" => "error", "message" => sprintf(__("There is no vacancy in the room on %s"), $date));
            				
            			}
            			
            			if($row['stop'] == 'true'){
            				
            				return array("status" => "error", "message" => sprintf(__("Booking on %s is suspended"), $date));
            					
            			}
            					
            			if($i != 0){
            				
            				$time = ($row['unixTime'] - $unixTime) / 60;
            				array_push($unixTimeList, $time);
            				$unixTime = $row['unixTime'];
            				if($time < 1440){
            					
            					return array("status" => "error", "message" => __("Schedule data was not found"), "sql" => $sql);
            					
            				}
            				
            			}else{
            				
            				$unixTime = $row['unixTime'];
            				
            			}
            			
            			$i++;
            			$nights++;
            			$totalCost += intval($row['cost']) * $applicantCount;
            			
            		}
            		
            		ksort($accommodationDetails['scheduleDetails']);
            		
            		$table_name = $wpdb->prefix."booking_package_schedule";
    				$sql = $wpdb->prepare("SELECT `key`,`month`,`day`,`year`,`weekKey`,`unixTime` FROM `".$table_name."` WHERE `key` = %d;", array(intval($jsonList['checkInKey'])));
            		$row = $wpdb->get_row($sql, ARRAY_A);
            		$accommodationDetails['checkInSchedule'] = $row;
            		
            		$sql = $wpdb->prepare("SELECT `key`,`month`,`day`,`year`,`weekKey`,`unixTime` FROM `".$table_name."` WHERE `key` = %d;", array(intval($jsonList['checkOutKey'])));
            		$row = $wpdb->get_row($sql, ARRAY_A);
            		$accommodationDetails['checkOutSchedule'] = $row;
            		
            		$sql_max_unixTime = $sql_start_unixTime;
            		for($i = 0; $i < count($unixTimeList); $i++){
            			
            			$sql_max_unixTime += $unixTimeList[$i] * 60;
            			
            		}
            		
            		$accommodationDetails['checkIn'] = intval($sql_start_unixTime);
            		$accommodationDetails['checkOut'] = intval($sql_max_unixTime) + (1440 * 60);
            		$accommodationDetails['lastUnixTime'] = intval($sql_max_unixTime);
            		$accommodationDetails['nights'] = $nights;
            		$accommodationDetails['accommodationFee'] = $totalCost;
            		$accommodationDetails['sql_max_unixTime'] = $sql_max_unixTime;
            		
            		$sql_max_unixTime += $maintenanceTime * 60;
            		
            		#$sql_max_unixTime = $sql_start_unixTime + ($courseTime * 60) + ($maintenanceTime * 60);
					$table_name = $wpdb->prefix."booking_package_schedule";
					$account_sql = "SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND (`unixTime` >= %d AND `unixTime` <= %d) ORDER BY `unixTime` ASC ;";
					$valueArray = array(intval($accountKey), intval($sql_start_unixTime), intval($sql_max_unixTime));
					$accommodationDetails['sql'] = $account_sql;
					$accommodationDetails['valueArray'] = $valueArray;
					$jsonList['sql'] = $wpdb->prepare($account_sql, $valueArray);
					
    			}
    			
    		}
    		
    		#var_dump(count($jsonList['guestsList']));
    		if(count($jsonList['guestsList']) != 0){
    			
    			/**
    			$additionalFee = 0;
            	$table_name = $wpdb->prefix."booking_package_guests";
            	$guestsList = $jsonList['guestsList'];
            	foreach($guestsList as $key => $value){
            		
            		$guestSql = $wpdb->prepare("SELECT * FROM `".$table_name."` WHERE `key` = %d AND `accountKey` = %d;", array(intval($key), intval($accountKey)));
            		$row = $wpdb->get_row($guestSql, ARRAY_A);
            		$guests = array();
            		$guestsArray = json_decode($row['json'], true);
            		for($i = 0; $i < count($guestsArray); $i++){
            			
            			if(intval($value['number']) == intval($guestsArray[$i]['number']) && $value['name'] == $guestsArray[$i]['name']){
            				
            				$additionalFee += intval($guestsArray[$i]['price']) * $nights;
            				$guestsArray[$i]['selected'] = 1;
            			
            			}else{
            				
            				$guestsArray[$i]['selected'] = 0;
            				
            			}
            			
            		}
            		
            		array_unshift($guestsArray, array("number" => 0, "price" => 0, "name" => "SELECT", "selected" => 0));
            		$row['json'] = $guestsArray;
            		$accommodationDetails['guestsList'][$key] = $row;
            		
            	}
            	**/
            	
            	$additionalFee = 0;
            	$table_name = $wpdb->prefix."booking_package_guests";
            	$guestsList = $jsonList['guestsList'];
            	foreach($guestsList as $key => $value){
            		
            		$guestSql = $wpdb->prepare("SELECT * FROM `".$table_name."` WHERE `key` = %d AND `accountKey` = %d;", array(intval($key), intval($accountKey)));
            		$guests_row = $wpdb->get_row($guestSql, ARRAY_A);
            		$guests = array();
            		$guestsArray = json_decode($guests_row['json'], true);
            		for($i = 0; $i < count($guestsArray); $i++){
            			
            			if(intval($value['number']) == intval($guestsArray[$i]['number']) && $value['name'] == $guestsArray[$i]['name']){
            				
            				$additionalFee += intval($guestsArray[$i]['price']) * $nights;
            				$guestsArray[$i]['selected'] = 1;
            				
            			}else{
            				
            				$guestsArray[$i]['selected'] = 0;
            				
            			}
            			
            		}
            		
            		array_unshift($guestsArray, array("number" => 0, "price" => 0, "name" => "SELECT", "selected" => 0));
            		$guests_row['json'] = $guestsArray;
            		$accommodationDetails['guestsList'][$key] = $guests_row;
            		
            	}
            	
            	$accommodationDetails['additionalFee'] = $additionalFee;
            	$accommodationDetails['adult'] = intval($jsonList['adult']);
            	$accommodationDetails['children'] = intval($jsonList['children']);
    			
    		}else{
    			
    			$accommodationDetails['additionalFee'] = 0;
    			
    		}
				
            #$accommodationDetails['type'] = $calendarAccount['type'];
            #$accommodationDetails['additionalFee'] = $additionalFee;
            $accommodationDetails['totalCost'] = $totalCost + $additionalFee;
            #$accommodationDetails['adult'] = intval($jsonList['adult']);
            #$accommodationDetails['children'] = intval($jsonList['children']);
            #$this->setAccommodationDetails($accommodationDetails);
    		return $accommodationDetails;
    		
    		/**	
    		}else{
    			
    			return array("status" => "error", "message" => __("Schedule data was not found"));
    			
    		}
    		**/
    		
    	}
    	
    	public function sendBooking(){
    		
    		$accountKey = 1;
    		if(isset($_POST['accountKey'])){
    			
    			$accountKey = $_POST['accountKey'];
    			
    		}
    		
    		$maintenanceTime = 0;
    		$remainderTime = 0;
    		$sendDate = date('U');
    		$totalCost = 0;
    		$courseKey = null;
    		$jsonList = null;
    		$ressponse = array();
    		$sql_start_unixTime = null;
    		$sql_max_unixTime = null;
    		
    		global $wpdb;
    		
    		$currency = get_option($this->prefix."currency", 'usd');
    		$dateFormat = intval(get_option($this->prefix."dateFormat", 0));
    		$positionOfWeek = get_option($this->prefix."positionOfWeek", "before");
    		
    		$calendarAccount = $this->getCalendarAccount($accountKey);
    		$form = $this->getUserValues($accountKey);
    		if(isset($form['status']) && $form['status'] == 'error'){
    			
    			return $form;
    			
    		}
    		
    		$table_name = $wpdb->prefix."booking_package_schedule";
    		$sql = $wpdb->prepare("SELECT * FROM `".$table_name."` WHERE `key` = %d;", array(intval($_POST['timeKey'])));
    		$row = $wpdb->get_row($sql, ARRAY_A);
    		if(is_null($row)){
    			
    			return array("status" => "error", "message" => __("Schedule data was not found"));
    			
    		}else{
    			
    			$scheduleUnixTime = intval($_POST['unixTime']);
    			$applicantCount = intval($_POST['applicantCount']);
    			$startTime = $row['unixTime'];
    			$sql_start_unixTime = $row['unixTime'];
    			
    			$scheduleTitle = $row['title'];
				$scheduleCost = intval($row['cost']);
				$totalCost += intval($row['cost']) * $applicantCount;
				
				if($row['unixTime'] == $scheduleUnixTime){
					
					if($calendarAccount['type'] == "hotel" && isset($_POST['json'])){
    					
    					/**
    					$nights = 0;
    					$totalCost = 0;
    					$accommodationDetails = array("scheduleList" => array(), "guestsList" => array());
    					$jsonList = json_decode(str_replace("\\", "", $_POST['json']), true);
    					$scheduleList = array_values($jsonList['list']);
    					$first = reset($scheduleList);
    					$last = end($scheduleList);
    					$table_name = $wpdb->prefix."booking_package_schedule";
    					$sql = $wpdb->prepare("SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND (`unixTime` >= %d AND `unixTime` <= %d) ORDER BY `unixTime` ASC;", array(intval($accountKey), intval($first['unixTime']), intval($last['unixTime'])));
    					$rows = $wpdb->get_results($sql, ARRAY_A);
    					if(count($rows) != 0 && !is_null($rows)){
    						
    						$unixTimeList = array();
    						$i = 0;
    						foreach($rows as $row){
            					
            					array_push($accommodationDetails['scheduleList'], $row['key']);
            					$date = $this->dateFormat($dateFormat, $positionOfWeek, $row['unixTime'], $row['title'], false);
            					if($row['remainder'] <= 0){
            						
            						return array("status" => "error", "message" => sprintf(__("There is no vacancy in the room on %s"), $date));
            						
            					}
            					
            					if($row['stop'] == 'true'){
            						
            						return array("status" => "error", "message" => sprintf(__("Booking on %s is suspended"), $date));
            						
            					}
            					
            					if($i != 0){
            						
            						$time = ($row['unixTime'] - $unixTime) / 60;
            						array_push($unixTimeList, $time);
            						$unixTime = $row['unixTime'];
            						if($time < 1440){
            							
            							return array("status" => "error", "message" => __("Schedule data was not found"));
            							
            						}
            						
            					}else{
            						
            						$unixTime = $row['unixTime'];
            						
            					}
            					
            					$i++;
            					$nights++;
            					$totalCost += intval($row['cost']) * $applicantCount;
            					
            				}
            				
            				
            				$sql_max_unixTime = $sql_start_unixTime;
            				for($i = 0; $i < count($unixTimeList); $i++){
            					
            					$sql_max_unixTime += $unixTimeList[$i] * 60;
            					
            				}
            				
            				$accommodationDetails['checkIn'] = intval($sql_start_unixTime);
            				$accommodationDetails['checkOut'] = intval($sql_max_unixTime) + (1440 * 60);
            				$accommodationDetails['lastUnixTime'] = intval($sql_max_unixTime);
            				
            				$jsonList['checkIn'] = intval($sql_start_unixTime);
            				$jsonList['checkOut'] = intval($sql_max_unixTime) + (1440 * 60);
            				$sql_max_unixTime += $maintenanceTime * 60;
            				
            				#$sql_max_unixTime = $sql_start_unixTime + ($courseTime * 60) + ($maintenanceTime * 60);
							$table_name = $wpdb->prefix."booking_package_schedule";
							$account_sql = "SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND (`unixTime` >= %d AND `unixTime` <= %d) ORDER BY `unixTime` ASC ;";
							$valueArray = array(intval($accountKey), intval($sql_start_unixTime), intval($sql_max_unixTime));
							$jsonList['sql'] = $wpdb->prepare($account_sql, $valueArray);
							
            				$additionalFee = 0;
            				$table_name = $wpdb->prefix."booking_package_guests";
            				$guestsList = $jsonList['guestsList'];
            				foreach($guestsList as $key => $value){
            					
            					$guestSql = $wpdb->prepare("SELECT * FROM `".$table_name."` WHERE `key` = %d AND `accountKey` = %d;", array(intval($key), intval($accountKey)));
            					$row = $wpdb->get_row($guestSql, ARRAY_A);
            					$guests = array();
            					$guestsArray = json_decode($row['json'], true);
            					for($i = 0; $i < count($guestsArray); $i++){
            						
            						if(intval($value['number']) == intval($guestsArray[$i]['number']) && $value['name'] == $guestsArray[$i]['name']){
            							
            							$additionalFee += intval($guestsArray[$i]['price']) * $nights;
            							$guestsArray[$i]['selected'] = 1;
            							
            						}else{
            							
            							$guestsArray[$i]['selected'] = 0;
            							
            						}
            						
            					}
            					
            					array_unshift($guestsArray, array("number" => 0, "price" => 0, "name" => "SELECT", "selected" => 0));
            					$row['json'] = $guestsArray;
            					$accommodationDetails['guestsList'][$key] = $row;
            					
            				}
            				
            				$accommodationDetails['type'] = $calendarAccount['type'];
            				$accommodationDetails['nights'] = $nights;
            				$accommodationDetails['additionalFee'] = $additionalFee;
            				$accommodationDetails['accommodationFee'] = $totalCost;
            				$accommodationDetails['totalCost'] = $totalCost + $additionalFee;
            				$accommodationDetails['adult'] = intval($jsonList['adult']);
            				$accommodationDetails['children'] = intval($jsonList['children']);
            				
            				$jsonList['type'] = $calendarAccount['type'];
            				$jsonList['unixTimeList'] = $unixTimeList;
            				$jsonList['nights'] = $nights;
            				$jsonList['additionalFee'] = $additionalFee;
            				$jsonList['totalCost'] = $totalCost + $additionalFee;
            				
            				unset($jsonList['booking']);
            				unset($jsonList['status']);
    						
    						$this->setAccommodationDetails($accommodationDetails);
    						
    					}else{
    						
    						return array("status" => "error", "message" => __("Schedule data was not found"));
    						
    					}
    					**/
    					
    					#createAccommodationDetails($calendarAccount, $json, $sql_start_unixTime, $applicantCount, $accommodationDetails = null)
    					$accommodationDetails = $this->createAccommodationDetails($calendarAccount, $_POST['json'], $sql_start_unixTime, $applicantCount, null);
    					#var_dump($accommodationDetails);
    					if($accommodationDetails['status'] == "error"){
    						
    						return $accommodationDetails;
    						
    					}else{
    						
    						$account_sql = $accommodationDetails['sql'];
    						$valueArray = $accommodationDetails['valueArray'];
    						$sql_max_unixTime = $accommodationDetails['sql_max_unixTime'];
    						unset($accommodationDetails['sql']);
    						unset($accommodationDetails['valueArray']);
    						unset($accommodationDetails['sql_max_unixTime']);
    						$this->setAccommodationDetails($accommodationDetails);
    						
    					}
    					
    				}else{
    					
    					$table_name = $wpdb->prefix."booking_package_schedule";
						$account_sql = "SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND `key` = %d;";
						$valueArray = array(intval($accountKey), intval($_POST['timeKey']));
						if(isset($_POST['courseKey'])){
							
							$row = $this->serachCourse($accountKey ,$_POST['courseKey']);
							if($row['status'] == 'error'){
            					
            					return array('status' => 'error', 'error' => '9020');
            					
            				}else{
            					
            					$courseKey = $_POST['courseKey'];
            					$courseName .= $row['name']."\n";
								$courseCost += intval($row['cost']);
								$courseTime += $row['time'];
								$totalCost += intval($row['cost']) * $applicantCount;
								
								$sql_max_unixTime = $sql_start_unixTime + ($courseTime * 60) + ($maintenanceTime * 60);
								$table_name = $wpdb->prefix."booking_package_schedule";
								$account_sql = "SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND (`unixTime` >= %d AND `unixTime` < %d) ORDER BY `unixTime` ASC ;";
								$valueArray = array(intval($accountKey), intval($sql_start_unixTime), intval($sql_max_unixTime));
            					
            				}
							
						}
    					
    				}
					
					/** Stripe **/
					$cardToken = null;
					if(isset($_POST['payToken'])){
						
						$stripe_active = get_option($this->prefix."stripe_active", "0");
						$stripe_secret_key = get_option($this->prefix."stripe_secret_key", null);
						$currency = get_option($this->prefix."currency", "usd");
						if($stripe_active == 1 && !is_null($stripe_secret_key)){
							
							$creditCard = new creditCard($this->pluginName);
							$payResponse = $creditCard->pay("stripe", $stripe_secret_key, $_POST['payToken'], $totalCost, $currency, $key, $name);
							if(isset($payResponse['error'])){
								
								return array('status' => 'error', 'error' => $payResponse['error']);
								
							}else{
								
								$cardToken = $payResponse['cardToken'];
								
							}
							
						}
						
					}
					/** Stripe **/
					
					$status = $this->getStatus();
					/**
					#$status = "pending";
					if($this->automaticApprove === true){
						
						#$status = "approved";
						$updateSchedule = $this->updateRemainderSeart("increase", $account_sql, $valueArray, $applicantCount);
						
					}
					**/
					
					$updateSchedule = $this->updateRemainderSeart("increase", $account_sql, $valueArray, $applicantCount);
					$lastID = $this->insertPrivateData($sendDate, $_POST['permission'], $status, $_POST['timeKey'], $scheduleUnixTime, $scheduleTitle, $scheduleCost, $courseKey, $courseName, $courseTime, $courseCost, $form, $currency, $cardToken, $accountKey, $applicantCount);
					
				}
    			
    		}
    		
    		$mailBody = null;
    		if(intval($_POST['sendEmail']) == 1){
    			
    			#$to = $this->emailFormat(get_option($this->prefix."email_to", null), get_option($this->prefix."email_title_to", null));
    			#$from = $this->emailFormat(get_option($this->prefix."email_from", null), get_option($this->prefix."email_title_from", null));
    			
    			#$emailFormat = get_option($this->prefix."mail_new_admin_format", null);
    			#$emailSubject = get_option($this->prefix."mail_new_admin_subject", null);
    			#$emailBody = get_option($this->prefix."mail_new_admin_content", null);
    			$email = $this->createEmailMessage($accountKey, array('mail_new_admin'), $form, $accommodationDetails, $lastID, $scheduleUnixTime, $emailSubject, $emailBody, $emailFormat, $to, $from, $courseName, $scheduleTitle);
    			
    		}
    		
    		if($calendarAccount['type'] == 'hotel'){
    			
    			$sql_max_unixTime += 1440 * 60;
    			
    		}
    		
    		$setting = new setting($this->prefix, $this->pluginName);
    		$googleCalendar = $setting->pushGC('insert', $accountKey, $calendarAccount['type'], $lastID, $calendarAccount['googleCalendarID'], $sql_start_unixTime, $sql_max_unixTime, $form);
    		$this->updateQueueForGC($lastID, $googleCalendar);
    		
    		$iCal = false;
    		$public = false;
    		if(intval($_POST['public']) == 1){
    			
    			$public = true;
    			
    		}
    		
    		$ressponse = $this->getReservationData(intval($_POST['month']), intval($_POST['day']), intval($_POST['year']), $iCal, $public);
    		$ressponse['account'] = $this->getCalendarAccount($accountKey);
    		$ressponse['automaticApprove'] = $this->automaticApprove;
    		#$ressponse['payResponse'] = $payResponse;
    		#$ressponse['Google_Calendar'] = $googleCalendar;
    		$ressponse['lastID'] = $lastID;
    		#$ressponse['params'] = $params;
    		#$ressponse['jsonList'] = $jsonList;
    		#$ressponse['accommodationDetails'] = $accommodationDetails;
    		$ressponse['sendVisitor'] = $email['sendVisitor'];
    		$ressponse['sendControl'] = $email['sendControl'];
    		$ressponse['status'] = "success";
    		return $ressponse;
    		
    		
    	}
    	
    	public function insertPrivateData($sendDate, $permission, $status, $timeKey, $scheduleUnixTime, $scheduleTitle, $scheduleCost, $courseKey, $courseName, $courseTime, $courseCost, $form, $currency, $cardToken, $accountKey, $applicantCount = 1){
    		
    		global $wpdb;
    		
    		$maintenanceTime = 0;
    		$remainderBool = 'false';
			if(($sendDate + ($remainderTime * 60)) > $scheduleUnixTime){
				
				$remainderBool = 'true';
				
			}
			
			$courseTitle = get_option($this->prefix."courseName", "Course");
			$numberOfWeek = ceil(date('d', $scheduleUnixTime) / 7);
			
			#$courseKey = intval($_POST['courseKey']);
			if(is_null($courseKey)){
				
				$courseKey = null;
				
			}
			
			$payMode = "";
			$payId = "";
			$payName = "";
			if($cardToken != null){
				
				$payMode = "CreditCard";
				$payId = "stripe";
				$payName = "Stripe";
				
			}
			
			$type = "day";
			$checkIn = 0;
			$checkOut = 0;
			$accommodationDetails = $this->getAccommodationDetails();
			if(!is_null($accommodationDetails)){
				
				$type = "hotel";
				$checkIn = $accommodationDetails['checkIn'];
				$checkOut = $accommodationDetails['checkOut'];
				
			}
			
			$table_name = $wpdb->prefix."booking_package_userPraivateData";
			$valueArray = array(
    		 					'reserveTime' => intval($sendDate), 
    		 					'remainderTime' => 0,
    							'remainderBool' => $remainderBool, 
    							'maintenanceTime' => intval($maintenanceTime),
    							'permission' => sanitize_text_field($permission),
    							'type' => $type,
    							'status' => sanitize_text_field($status),
    							'accountKey' => intval($accountKey),
    							'accountName' => '',
    							'scheduleUnixTime' => intval($scheduleUnixTime),
    							'scheduleWeek' => intval($numberOfWeek),
    							'scheduleTitle' => sanitize_text_field($scheduleTitle),
    							'scheduleKey' => intval($timeKey),
    							'scheduleCost' => intval($scheduleCost),
    							'applicantCount' => intval($applicantCount),
    							'courseKey' => sanitize_text_field($courseKey),
    							'courseTitle' => sanitize_text_field($courseTitle),
    							'courseName' => sanitize_text_field($courseName),
    							'courseTime' => intval($courseTime),
    							'courseCost' => intval($courseCost),
    							'currency' => sanitize_text_field($currency),
    							'payMode' => $payMode,
    							'payId' => $payId,
    							'payName' => $payName,
    							'payToken' => sanitize_text_field($cardToken),
    							'praivateData' => json_encode($form),
    							'checkIn' => intval($checkIn),
    							'checkOut' => intval($checkOut),
    							'accommodationDetails' => json_encode($accommodationDetails),
    						);
    		
			$bool = $wpdb->insert(	$table_name, 
    								$valueArray, 
    								array(	'%d', '%d', '%s', '%d', '%s', '%s', '%s', '%d', '%s', '%d',
    										'%d', '%s', '%d', '%d', '%d', '%s', '%s', '%s', '%d', '%d', 
    										'%s', '%s', '%s', '%s', '%s', '%s', '%d', '%d', '%s'
    								)
    							);
			#$ressponse['insert'] = $bool;
			$lastID = $wpdb->insert_id;
			
			return $lastID;
    		
    	}
    	
    	public function deleteBookingData($deleteKey = false, $sendGC = true){
    		
    		$accountKey = 1;
    		if(isset($_POST['accountKey'])){
    			
    			$accountKey = $_POST['accountKey'];
    			
    		}
    		
    		global $wpdb;
    		$calendarAccount = $this->getCalendarAccount($accountKey);
    		if($deleteKey !== false){
    			
    			$unixTimeStart = 0;
    			$form = null;
    			$table_name = $wpdb->prefix."booking_package_userPraivateData";
    			$sql = "SELECT * FROM `".$table_name."` WHERE `key` = %d;";
    			$sql = $wpdb->prepare("SELECT * FROM `".$table_name."` WHERE `key` = %d;", array(intval($deleteKey)));
    			$row = $wpdb->get_row($sql, ARRAY_A);
            	if(is_null($row) === false){
            		
            		$accountKey = $row['accountKey'];
            		$iCalIDforGoogleCalendar = $row['iCalIDforGoogleCalendar'];
            		$form = json_decode($row['praivateData']);
            		$table_name = $wpdb->prefix."booking_package_schedule";
            		$sql = null;
            		$month = date('m', $row['scheduleUnixTime']);
            		$year = date('Y', $row['scheduleUnixTime']);
            		$applicantCount = $row['applicantCount'];
            		$payToken = $row['payToken'];
            		$scheduleTitle = $row['scheduleTitle'];
            		$courseName = $row['courseName'];
            		
            		if($calendarAccount['type'] == 'hotel'){
            			
            			$accommodationDetails = json_decode($row['accommodationDetails'], true);
            			$endKey = end($accommodationDetails['scheduleList']);
            			$unixTimeStart = $row['scheduleUnixTime'];
            			$unixTimeEnd = $accommodationDetails['lastUnixTime'];
            			$account_sql = "SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND (`unixTime` >= %d AND `unixTime` <= %d) ORDER BY `unixTime` ASC ;";
						$valueArray = array(intval($accountKey), intval($unixTimeStart), intval($unixTimeEnd));
						$sql = $wpdb->prepare($account_sql, $valueArray);
            			
            		}else{
            			
            			$unixTimeStart = $row['scheduleUnixTime'];
						$unixTimeEnd = $row['scheduleUnixTime'] + ($row['courseTime'] * 60) + ($row['maintenanceTime'] * 60);
						$valueArray = array();
            			if(strlen($row['courseKey']) != 0){
            				
            				$sql = "SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND (`unixTime` >= %d AND `unixTime` < %d) ORDER BY `unixTime` ASC;";
            				$valueArray = array(intval($accountKey), intval($unixTimeStart), intval($unixTimeEnd));
            				
            			}else{
            				
            				$sql = "SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND `key` = %d;";
            				$valueArray = array(intval($accountKey), intval($row['scheduleKey']));
            				
            			}
            			
            		}
            		
            		
            		
            		/**
            		if($row['status'] == 'approved'){
            			
            			$updateSchedule = $this->updateRemainderSeart("reduce", $sql, $valueArray, $applicantCount);
            			
            		}
            		**/
            		
            		$updateSchedule = $this->updateRemainderSeart("reduce", $sql, $valueArray, $applicantCount);
            		
            		if(isset($_POST['refound']) && intval($_POST['refound']) == 1){
            			
            			$stripe_active = get_option($this->prefix."stripe_active", "0");
						$stripe_secret_key = get_option($this->prefix."stripe_secret_key", null);
						$currency = get_option($this->prefix."currency", "usd");
						if($stripe_active == 1 && !is_null($stripe_secret_key)){
							
							#$payToken
            				$creditCard = new creditCard();
            				$refound = $creditCard->cancel("stripe", $stripe_secret_key, $payToken);
							
						}
            			
            		}
            		
            		$table_name = $wpdb->prefix."booking_package_userPraivateData";
            		$wpdb->delete($table_name, array('key' => intval($deleteKey)), array('%d'));
            		
            		$ressponse = $this->getReservationData($month, 1, $year);
    				$ressponse['status'] = "success";
    				$ressponse['refound'] = $refound;
    				$ressponse['sql'] = $sql;
    				
    				$mailBody = null;
    				#if(intval(get_option($this->prefix."mail_deleted_enable", null)) == 1 && intval($_POST['sendEmail']) == 1){
    				if(intval($_POST['sendEmail']) == 1){
    					
    					#$to = $this->emailFormat(get_option($this->prefix."email_to", null), get_option($this->prefix."email_title_to", null));
    					#$from = $this->emailFormat(get_option($this->prefix."email_from", null), get_option($this->prefix."email_title_from", null));
    					
    					#$emailFormat = get_option($this->prefix."mail_deleted_format", null);
    					#$emailSubject = get_option($this->prefix."mail_deleted_subject", null);
    					#$emailBody = get_option($this->prefix."mail_deleted_content", null);
    					$email = $this->createEmailMessage($accountKey, array('mail_deleted'), $form, $accommodationDetails, $deleteKey, intval($unixTimeStart), $emailSubject, $emailBody, $emailFormat, $to, $from, $courseName, $scheduleTitle);
    					$ressponse['email'] = $email;
    					
    				}
    				
    				if($sendGC === true){
    					
    					$setting = new setting($this->prefix, $this->pluginName);
    					$ressponse['delete'] = $setting->deleteGC($accountKey, $iCalIDforGoogleCalendar, $calendarAccount['googleCalendarID']);
    					
    				}
    				
            		
            		return $ressponse;
            		
            	}else{
            		
            		return array('error' => 'ERROR3', 'status' => 'error');
            		
            	}
    			
    		}
    		
    	}
    	
    	public function retryToSendToServer(){
    		
    		global $wpdb;
    		#$calendarAccountList = $this->getCalendarAccountListData();
    		$setting = new setting($this->prefix, $this->pluginName);
    		$table_name = $wpdb->prefix."booking_package_userPraivateData";
			$sql = $wpdb->prepare("SELECT * FROM `".$table_name."` WHERE `resultOfGoogleCalendar` = %d;", array(0));
			$rows = $wpdb->get_results($sql, ARRAY_A);
			if(is_null($rows) === false && count($rows) != 0){
				
				for($row = 0; $row < count($rows); $row++){
					
					
					$form = json_decode($rows[$row]['praivateData']);
					$data = $rows[$row];
					$accountKey = $data['accountKey'];
					$key = $data['key'];
					$sql_start_unixTime = $data['scheduleUnixTime'];
					$sql_max_unixTime = $sql_start_unixTime + ($data['courseTime'] * 60) + ($data['maintenanceTime'] * 60);
					#var_dump($data);
					$iCalID = false;
					if(!is_null($data['iCalIDforGoogleCalendar']) && is_string($data['iCalIDforGoogleCalendar'])){
						
						$iCalID = $data['iCalIDforGoogleCalendar'];
						
					}
					
					$calendarAccount = $this->getCalendarAccount($accountKey);
					
					$googleCalendar = $setting->pushGC(
						$data['resultModeOfGoogleCalendar'], 
						$accountKey, 
						$calendarAccount['type'],
						$key, 
						$calendarAccount['googleCalendarID'],
						$sql_start_unixTime, 
						$sql_max_unixTime, 
						$form,
						$iCalID
					);
					
					$this->updateQueueForGC($key, $googleCalendar);
					
				}
				
			}
    		
    	}
    	
    	public function updateQueueForGC($key, $googleCalendar){
    		
    		global $wpdb;
    		if(isset($googleCalendar->responseStatus) && isset($googleCalendar->responseMode)){
    			
    			$valueList = array(
    				'resultOfGoogleCalendar' => intval($googleCalendar->responseStatus), 
    				'resultModeOfGoogleCalendar' => sanitize_text_field($googleCalendar->responseMode)
    			);
    			$formatList = array('%s', '%s');
    			if(isset($googleCalendar->id)){
    				
    				$valueList['iCalIDforGoogleCalendar'] = sanitize_text_field($googleCalendar->id);
    				array_push($formatList, '%s');
    				
    			}
    			
    			$table_name = $wpdb->prefix."booking_package_userPraivateData";
    			$bool = $wpdb->update(  
    				$table_name,
                    /**array('iCalIDforGoogleCalendar' => sanitize_text_field($googleCalendar->id)),**/
					$valueList,
					array('key' => intval($key)),
					$formatList,
					array('%d')
				);
    				
    		}
    		
    	}
    	
    	public function updateBooking(){
    		
    		$accountKey = 1;
    		if(isset($_POST['accountKey'])){
    			
    			$accountKey = $_POST['accountKey'];
    			
    		}
    		
    		global $wpdb;
    		$calendarAccount = $this->getCalendarAccount($accountKey);
    		$form = $this->getUserValues($accountKey);
    		if(isset($form['status']) && $form['status'] == 'error'){
    			
    			return $form;
    			
    		}
    		
    		$unixTimeStart = 0;
    		$unixTimeEnd = 0;
    		$maintenanceTime = 0;
    		$table_name = $wpdb->prefix."booking_package_userPraivateData";
    		$sql = "SELECT * FROM `".$table_name."` WHERE `key` = %d;";
    		$sql = $wpdb->prepare("SELECT * FROM `".$table_name."` WHERE `key` = %d;", array(intval($_POST['updateKey'])));
    		$row = $wpdb->get_row($sql, ARRAY_A);
            if(is_null($row) === false){
            	
            	$applicantCount = $row['applicantCount'];
            	$iCalIDforGoogleCalendar = $row['iCalIDforGoogleCalendar'];
				#$form = json_decode($row['praivateData']);
				$unixTimeStart = $row['scheduleUnixTime'];
				$unixTimeEnd = $row['scheduleUnixTime'] + ($row['courseTime'] * 60) + ($row['maintenanceTime'] * 60);
				
				if($calendarAccount['type'] == 'hotel'){
					
					#createAccommodationDetails($calendarAccount, $json, $sql_start_unixTime, $applicantCount, $accommodationDetails = null)
    				$accommodationDetails = json_decode($row['accommodationDetails'], true);
    				$accommodationDetails = $this->createAccommodationDetails($calendarAccount, $_POST['json'], $unixTimeStart, $applicantCount, $accommodationDetails);
    				if($accommodationDetails['status'] == "error"){
    					
    					return $accommodationDetails;
    					
    				}else{
    					
    					$account_sql = $accommodationDetails['sql'];
    					$valueArray = $accommodationDetails['valueArray'];
    					$unixTimeEnd = $accommodationDetails['sql_max_unixTime'];
    					unset($accommodationDetails['sql']);
    					unset($accommodationDetails['valueArray']);
    					unset($accommodationDetails['sql_max_unixTime']);
    					$this->setAccommodationDetails($accommodationDetails);
    					
    				}
					
					/**
					$accommodationDetails = json_decode($row['accommodationDetails'], true);
					$unixTimeEnd = $accommodationDetails['checkOut'];
					$nights = $accommodationDetails['nights'];
					$additionalFee = $accommodationDetails['additionalFee'];
    				$totalCost = $accommodationDetails['accommodationFee'];
    				$jsonList = json_decode(str_replace("\\", "", $_POST['json']), true);
    				$scheduleList = array_values($jsonList['list']);
    				$first = null;
    				$last = null;
    				if(count($scheduleList) != 0){
    					
    					$nights = 0;
    					$totalCost = 0;
    					$first = reset($scheduleList);
    					$last = end($scheduleList);
    					$table_name = $wpdb->prefix."booking_package_schedule";
    					$sql = $wpdb->prepare("SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND (`unixTime` >= %d AND `unixTime` <= %d) ORDER BY `unixTime` ASC;", array(intval($accountKey), intval($first['unixTime']), intval($last['unixTime'])));
    					$schedule_rows = $wpdb->get_results($sql, ARRAY_A);
    					if(count($schedule_rows) != 0 && !is_null($schedule_rows)){
    						
    						
    						
    					}
    				
    				}
    				
    				if(count($jsonList['guestsList']) != 0){
    					
    					$additionalFee = 0;
            			$table_name = $wpdb->prefix."booking_package_guests";
            			$guestsList = $jsonList['guestsList'];
            			foreach($guestsList as $key => $value){
            				
            				$guestSql = $wpdb->prepare("SELECT * FROM `".$table_name."` WHERE `key` = %d AND `accountKey` = %d;", array(intval($key), intval($accountKey)));
            				$guests_row = $wpdb->get_row($guestSql, ARRAY_A);
            				$guests = array();
            				$guestsArray = json_decode($guests_row['json'], true);
            				for($i = 0; $i < count($guestsArray); $i++){
            					
            					if(intval($value['number']) == intval($guestsArray[$i]['number']) && $value['name'] == $guestsArray[$i]['name']){
            						
            						$additionalFee += intval($guestsArray[$i]['price']) * $nights;
            						$guestsArray[$i]['selected'] = 1;
            						
            					}else{
            						
            						$guestsArray[$i]['selected'] = 0;
            						
            					}
            					
            				}
            				
            				array_unshift($guestsArray, array("number" => 0, "price" => 0, "name" => "SELECT", "selected" => 0));
            				$guests_row['json'] = $guestsArray;
            				$accommodationDetails['guestsList'][$key] = $guests_row;
            				
            			}
            			
            			$accommodationDetails['additionalFee'] = $additionalFee;
            			$accommodationDetails['adult'] = intval($jsonList['adult']);
            			$accommodationDetails['children'] = intval($jsonList['children']);
    					
    				}
    				
    				#$accommodationDetails['type'] = $calendarAccount['type'];
            		#$accommodationDetails['nights'] = $nights;
            		#$accommodationDetails['accommodationFee'] = $totalCost;
            		
            		$accommodationDetails['totalCost'] = $totalCost + $additionalFee;
            		
            				
    				$this->setAccommodationDetails($accommodationDetails);
					**/
					
				}
				
            	if(isset($_POST['update_booking_date']) || isset($_POST['update_booking_course'])){
            		
            		define("COURSE_KEY", $row['courseKey']);
    				
    				$table_name = $wpdb->prefix."booking_package_schedule";
    				
    				$scheduleKey = $row['scheduleKey'];
    				$scheduleUnixTime = $row['scheduleUnixTime'];
    				$scheduleTitle = $row['scheduleTitle'];
    				$scheduleCost = $row['scheduleCost'];
    				$scheduleWeek = $row['scheduleWeek'];
    				
    				$courseKey = $row['courseKey'];
    				$courseName = $row['courseName'];
    				$courseTime = $row['courseTime'];
    				$courseCost = $row['courseCost'];
    				
    				$deleteSql = null;
    				$deleteValueArray = array();
    				$updateSql = null;
    				$updateValueArray = array();
    				
    				if($calendarAccount['type'] == 'hotel'){
    					
    					
    					
    				}else{
    					
    					$unixTimeStart = $scheduleUnixTime;
						$unixTimeEnd = $scheduleUnixTime + ($courseTime * 60) + ($row['maintenanceTime'] * 60);
						$deleteValueArray = array();
            			if(strlen(COURSE_KEY) != 0){
            				
            				$deleteSql = "SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND (`unixTime` >= %d AND `unixTime` < %d) ORDER BY `unixTime` ASC;";
            				$deleteValueArray = array(intval($accountKey), intval($unixTimeStart), intval($unixTimeEnd));
            				$sql = $wpdb->prepare($deleteSql, $deleteValueArray);
            				#var_dump($sql);
            				
            			}else{
            				
            				$deleteSql = "SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND `key` = %d;";
            				$deleteValueArray = array(intval($accountKey), intval($scheduleKey));
            				
            			}
            			
            			if(isset($_POST['update_booking_date'])){
    						
    						$table_name = $wpdb->prefix."booking_package_schedule";
    						$sql = $wpdb->prepare("SELECT * FROM `".$table_name."` WHERE `key` = %d;", array(intval($_POST['update_booking_date'])));
    						$rowSchedule = $wpdb->get_row($sql, ARRAY_A);
    						if(is_null($rowSchedule)){
    							
    							return array('status' => 'error', 'error' => '9016');
    							
    						}else{
    							
    							$scheduleKey = $rowSchedule['key'];
    							$scheduleUnixTime = $rowSchedule['unixTime'];
    							$scheduleTitle = $rowSchedule['title'];
    							$scheduleCost = $rowSchedule['cost'];
    							$scheduleWeek = $rowSchedule['weekKey'];
    							
    						}
    						
    					}
    					
    					if(isset($_POST['update_booking_course'])){
    						
    						$rowCourse = $this->serachCourse($accountKey, $_POST['update_booking_course']);
							if($rowCourse['status'] == 'error'){
            					
            					return array('status' => 'error', 'error' => '9020');
            					
            				}else{
            					
            					$courseKey = $rowCourse['key'];
    							$courseName = $rowCourse['name'];
    							$courseTime = $rowCourse['time'];
    							$courseCost = $rowCourse['cost'];
            					
            				}
    						
    					}
    					
    					$unixTimeStart = $scheduleUnixTime;
						$unixTimeEnd = $scheduleUnixTime + ($courseTime * 60) + ($row['maintenanceTime'] * 60);
						$updateValueArray = array();
    					if(strlen(COURSE_KEY) != 0){
            				
            				$updateSql = "SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND (`unixTime` >= %d AND `unixTime` < %d) ORDER BY `unixTime` ASC;";
            				$updateValueArray = array(intval($accountKey), intval($unixTimeStart), intval($unixTimeEnd));
            				
            			}else{
            				
            				$updateSql = "SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND `key` = %d;";
            				$updateValueArray = array(intval($accountKey), intval($scheduleKey));
            				
            			}
    					
    				}
    				
    				/**
            		$unixTimeStart = $scheduleUnixTime;
					$unixTimeEnd = $scheduleUnixTime + ($courseTime * 60) + ($row['maintenanceTime'] * 60);
					$deleteValueArray = array();
            		if(strlen(COURSE_KEY) != 0){
            			
            			$deleteSql = "SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND (`unixTime` >= %d AND `unixTime` < %d) ORDER BY `unixTime` ASC;";
            			$deleteValueArray = array(intval($accountKey), intval($unixTimeStart), intval($unixTimeEnd));
            			$sql = $wpdb->prepare($deleteSql, $deleteValueArray);
            			#var_dump($sql);
            			
            		}else{
            			
            			$deleteSql = "SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND `key` = %d;";
            			$deleteValueArray = array(intval($accountKey), intval($scheduleKey));
            			
            		}
            		
            		if(isset($_POST['update_booking_date'])){
    					
    					$table_name = $wpdb->prefix."booking_package_schedule";
    					$sql = $wpdb->prepare("SELECT * FROM `".$table_name."` WHERE `key` = %d;", array(intval($_POST['update_booking_date'])));
    					$rowSchedule = $wpdb->get_row($sql, ARRAY_A);
    					if(is_null($rowSchedule)){
    						
    						return array('status' => 'error', 'error' => '9016');
    						
    					}else{
    						
    						$scheduleKey = $rowSchedule['key'];
    						$scheduleUnixTime = $rowSchedule['unixTime'];
    						$scheduleTitle = $rowSchedule['title'];
    						$scheduleCost = $rowSchedule['cost'];
    						$scheduleWeek = $rowSchedule['weekKey'];
    						
    					}
    					
    				}
    				
    				if(isset($_POST['update_booking_course'])){
    					
    					$rowCourse = $this->serachCourse($accountKey, $_POST['update_booking_course']);
						if($rowCourse['status'] == 'error'){
            				
            				return array('status' => 'error', 'error' => '9020');
            				
            			}else{
            				
            				$courseKey = $rowCourse['key'];
    						$courseName = $rowCourse['name'];
    						$courseTime = $rowCourse['time'];
    						$courseCost = $rowCourse['cost'];
            				
            			}
    					
    				}
    				
    				$unixTimeStart = $scheduleUnixTime;
					$unixTimeEnd = $scheduleUnixTime + ($courseTime * 60) + ($row['maintenanceTime'] * 60);
					$updateValueArray = array();
    				if(strlen(COURSE_KEY) != 0){
            			
            			$updateSql = "SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND (`unixTime` >= %d AND `unixTime` < %d) ORDER BY `unixTime` ASC;";
            			$updateValueArray = array(intval($accountKey), intval($unixTimeStart), intval($unixTimeEnd));
            			
            		}else{
            			
            			$updateSql = "SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND `key` = %d;";
            			$updateValueArray = array(intval($accountKey), intval($scheduleKey));
            			
            		}
            		**/
            		
            		/**
            		if($row['status'] == 'approved'){
            			
            			$updateSchedule = $this->updateRemainderSeart("reduce", $deleteSql, $deleteValueArray, $applicantCount);
            			$updateSchedule = $this->updateRemainderSeart("increase", $updateSql, $updateValueArray, $applicantCount);
            			
            		}
            		**/
            		
            		$updateSchedule = $this->updateRemainderSeart("reduce", $deleteSql, $deleteValueArray, $applicantCount);
            		$updateSchedule = $this->updateRemainderSeart("increase", $updateSql, $updateValueArray, $applicantCount);
            		
            		$table_name = $wpdb->prefix."booking_package_userPraivateData";
    				$bool = $wpdb->update(
    					$table_name,
                    	array(
                    		'scheduleKey' => intval($scheduleKey), 
                    		'scheduleUnixTime' => intval($scheduleUnixTime),
                    		'scheduleTitle' => sanitize_text_field($scheduleTitle), 
                    		'scheduleCost' => intval($scheduleCost), 
                    		'scheduleWeek' => intval($scheduleWeek),
                    		'courseKey' => sanitize_text_field($courseKey), 
                    		'courseName' => sanitize_text_field($courseName),
                    		'courseTime' => intval($courseTime),
                    		'courseCost' => intval($courseCost)
                    	),
                    	array('key' => intval($_POST['updateKey'])),
                    	array('%d', '%d', '%s', '%d', '%d', '%s', '%s', '%d', '%d'),
                    	array('%d')
					);
    				
    			}
            	
            	
				$checkIn = 0;
				$checkOut = 0;
				$accommodationDetails = $this->getAccommodationDetails();
				if(!is_null($accommodationDetails)){
					
					$checkIn = $accommodationDetails['checkIn'];
					$checkOut = $accommodationDetails['checkOut'];
					
				}
				
				$table_name = $wpdb->prefix."booking_package_userPraivateData";
    			$bool = $wpdb->update(
    				$table_name,
    				array(
    					'praivateData' => json_encode($form), 
    					'accommodationDetails' => json_encode($accommodationDetails), 
    					'checkIn' => intval($checkIn), 
    					'checkOut' => intval($checkOut)
    				),
    				array('key' => intval($_POST['updateKey'])),
    				array('%s', '%s', '%d', '%d'),
    				array('%d')
				);
				
            }
    		
    		
					
			$googleCalendar = array();
    		if(strlen($iCalIDforGoogleCalendar) != 0){
    			
    			if($calendarAccount['type'] == 'hotel'){
    				
    				
    				
    			}
    			
    			$setting = new setting($this->prefix, $this->pluginName);
    			$googleCalendar = $setting->pushGC('update', $accountKey, $calendarAccount['type'], intval($_POST['updateKey']), $calendarAccount['googleCalendarID'], $unixTimeStart, $unixTimeEnd, $form, $iCalIDforGoogleCalendar);
    			$this->updateQueueForGC(intval($_POST['updateKey']), $googleCalendar);
    			
    		}else{
    			
    			$googleCalendar['error'] = "No ID";
    			
    		}
    		
    		$ressponse = $this->getReservationData(intval($_POST['month']), 1, intval($_POST['year']));
    		$ressponse['googleCalendar'] = $googleCalendar;
    		$ressponse['status'] = "success";
    		$ressponse['accommodationDetails'] = $accommodationDetails;
            
            return $ressponse;
    		
    	}
    	
    	public function serachGoogleCalendarIdOfVisitor($googleCalendarId = false){
        	
        	global $wpdb;
        	$table_name = $wpdb->prefix."booking_package_userPraivateData";
        	if($googleCalendarId != false){
        		
        		$sql = $wpdb->prepare("SELECT `key`,`iCalIDforGoogleCalendar`,`resultOfGoogleCalendar`,`resultModeOfGoogleCalendar` FROM ".$table_name." WHERE `iCalIDforGoogleCalendar` = %s;", array(sanitize_text_field($googleCalendarId)));
        		$row = $wpdb->get_row($sql, ARRAY_A);
				
        		return $row;
        		
        	}
        	
        	return false;
        	
        }
    	
    	public function updateICalIDforGoogleCalendar($id, $iCalIDforGoogleCalendar){
    		
    		global $wpdb;
    		$table_name = $wpdb->prefix."booking_package_userPraivateData";
    		$bool = $wpdb->update(  
    								$table_name,
    								array(
    									'iCalIDforGoogleCalendar' => sanitize_text_field($iCalIDforGoogleCalendar),
    									'resultOfGoogleCalendar' => 1
    								),
									array('key' => intval($id)),
									array('%s', '%d'),
									array('%d')
								);
    		
    	}
    	
    	public function updateStatus(){
    		
    		global $wpdb;
    		
    		$iCalIDforGoogleCalendar = null;
    		$unixTimeStart = 0;
    		$unixTimeEnd = 0;
    		$maintenanceTime = 0;
    		$form = null;
    		$table_name = $wpdb->prefix."booking_package_userPraivateData";
    		$sql = "SELECT * FROM `".$table_name."` WHERE `key` = %d;";
    		$sql = $wpdb->prepare("SELECT * FROM `".$table_name."` WHERE `key` = %d;", array(intval($_POST['key'])));
    		$row = $wpdb->get_row($sql, ARRAY_A);
            if(is_null($row) === false){
            	
            	$accountKey = $row['accountKey'];
            	$accommodationDetails = json_decode($row['accommodationDetails'], true);
            	$iCalIDforGoogleCalendar = $row['iCalIDforGoogleCalendar'];
				$form = json_decode($row['praivateData']);
				$applicantCount = $row['applicantCount'];
				$scheduleTitle = $row['scheduleTitle'];
				$unixTimeStart = $row['scheduleUnixTime'];
				$courseName = $row['courseName'];
				$account_sql = null;
				$valueArray = array();
				$table_name = $wpdb->prefix."booking_package_schedule";
				$unixTimeEnd = $row['scheduleUnixTime'] + ($row['courseTime'] * 60) + ($row['maintenanceTime'] * 60);
				if(strlen($row['courseKey']) != 0){
            		
            		$account_sql = "SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND (`unixTime` >= %d AND `unixTime` < %d) ORDER BY `unixTime` ASC;";
            		$valueArray = array(1, intval($unixTimeStart), intval($unixTimeEnd));
            		
            	}else{
            		
            		$account_sql = "SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND `key` = %d;";
            		$valueArray = array(1, intval($row['scheduleKey']));
            		
            	}
            	
            	/**
            	if($_POST['status'] == "approved"){
    				
    				$updateSchedule = $this->updateRemainderSeart("increase", $account_sql, $valueArray, $applicantCount);
    				
    			}else if($_POST['status'] == "pending"){
    				
            		$updateSchedule = $this->updateRemainderSeart("reduce", $account_sql, $valueArray, $applicantCount);
    				
    			}
    			**/
    			
    			$table_name = $wpdb->prefix."booking_package_userPraivateData";
    			$bool = $wpdb->update(  $table_name,
                            		array('status' => sanitize_text_field($_POST['status'])),
                            		array('key' => intval($_POST['key'])),
                            		array('%s'),
                            		array('%d')
								);
            		
            }
            
            $email_id = null;
            $enableEmail = null;
            $emailFormat = null;
            $emailSubject = null;
            $emailBody = null;
            if($_POST['status'] == "pending"){
            	
            	$email_id = 'mail_pending';
            	
            	$enableEmail = intval(get_option($this->prefix."mail_pending_enable", null));
            	$emailFormat = get_option($this->prefix."mail_pending_format", null);
    			$emailSubject = get_option($this->prefix."mail_pending_subject", null);
    			$emailBody = get_option($this->prefix."mail_pending_content", null);
            	
            }else if($_POST['status'] == "approved"){
            	
            	$email_id = 'mail_approved';
            	
            	$enableEmail = intval(get_option($this->prefix."mail_approved_enable", null));
            	$emailFormat = get_option($this->prefix."mail_approved_format", null);
    			$emailSubject = get_option($this->prefix."mail_approved_subject", null);
    			$emailBody = get_option($this->prefix."mail_approved_content", null);
            	
            }
            
            $mailBody = null;
    		#if($enableEmail == 1 && intval($_POST['sendEmail']) == 1){
    		if(intval($_POST['sendEmail']) == 1){
    			
    			#$to = $this->emailFormat(get_option($this->prefix."email_to", null), get_option($this->prefix."email_title_to", null));
    			#$from = $this->emailFormat(get_option($this->prefix."email_from", null), get_option($this->prefix."email_title_from", null));
    			
    			$email = $this->createEmailMessage($accountKey, array($email_id), $form, $accommodationDetails, intval($_POST['key']), intval($unixTimeStart), $emailSubject, $emailBody, $emailFormat, $to, $from, $courseName, $scheduleTitle);
    			#return $email;
    		}
    		
    		
    		$ressponse = array();
    		if(intval($_POST['reload']) == 1){
    			
    			$ressponse = $this->getReservationData(intval($_POST['month']), 1, intval($_POST['year']));
    			
    		}
    		
    		$ressponse['status'] = "success";
    		$ressponse['googleCalendar'] = $googleCalendar;
    		return $ressponse;
    		
    	}
    	
    	public function changeBookingTime($mode, $updateKey, $updateScheduleKey, $status, $applicantCount, $newTimeStart, $newTimeEnd, $oldTimeStart, $oldTimeEnd, $accommodationDetails, $accountKey = 1){
    		
    		#var_dump($mode);
    		global $wpdb;
    		
    		$checkIn = 0;
    		$checkOut = 0;
    		$changeBool = true;
    		$scheduleDetail = null;
    		$table_name = $wpdb->prefix."booking_package_schedule";
    		$updateSql = "SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND (`unixTime` >= %d AND `unixTime` < %d) ORDER BY `unixTime` ASC ;";
			$updateValue = array(intval($accountKey), intval($newTimeStart), intval($newTimeEnd));
			if($newTimeStart == $newTimeEnd){
				
				$updateSql = "SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND `unixTime` = %d;";
				$updateValue = array(intval($accountKey), intval($newTimeStart));
				
			}
			
			if(isset($accommodationDetails['sql']) && isset($accommodationDetails['valueArray'])){
				
				$updateSql = $accommodationDetails['sql'];
				$updateValue = $accommodationDetails['valueArray'];
				
			}
			
    		$sql = $wpdb->prepare($updateSql, $updateValue);
    		#var_dump($sql);
			$rows = $wpdb->get_results($sql, ARRAY_A);
			
			if(count($rows) == 0 || $rows[0]['unixTime'] != $newTimeStart){
				
				return array('status' => 'error', 'event' => 'return', 'message' => 'There is no booking schedule.');
				
			}
			
			
			foreach($rows as $row){
				
				if(!is_null($oldTimeStart) && !is_null($oldTimeEnd)){
					
					if($oldTimeStart != $oldTimeEnd){
						
						if($oldTimeStart <= $row['unixTime'] && $oldTimeEnd > $row['unixTime']){
							
							$row['remainder'] += $applicantCount;
							
						}
						
					}else{
						
						if($oldTimeStart == $row['unixTime']){
							
							$row['remainder'] += $applicantCount;
							
						}
						
					}
					
				}
				
				$row['remainder'] -= $applicantCount;
				#print "key = ".$row['key']." unixTime = ".$row['unixTime']." time = ".$row['hour'].":".$row['min']." capacity = ".$row['capacity']." remainder = ".$row['remainder']."<br>";
				if($row['remainder'] < 0 || $row['stop'] == 'true'){
					
					$changeBool = false;
					return array('status' => 'error', 'event' => 'return', 'message' => 'There is not enough remainder in the capacity.');
					break;
					
				}else{
					
					if(is_null($scheduleDetail)){
						
						$scheduleDetail = $row;
						
					}
					
				}
				
			}
			
			
			
			if($changeBool === true){
				
				$newCourseTime = ($newTimeEnd - $newTimeStart) / 60;
				$oldCourseTime = ($oldTimeEnd - $oldTimeStart) / 60;
				#print "courseTime = ".$newCourseTime."<br>";
				#var_dump($scheduleDetail);
				
				if($mode == 'update'){
					
					$checkIn = 0;
					$checkOut = 0;
					$deleteSql = "SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND (`unixTime` >= %d AND `unixTime` < %d) ORDER BY `unixTime` ASC ;";
					$deleteValue = array(intval($accountKey), intval($oldTimeStart), intval($oldTimeEnd));
					if($oldTimeStart == $oldTimeEnd){
						
						$deleteSql = "SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND `key` = %d;";
						$deleteValue = array(intval($accountKey), intval($updateScheduleKey));
						
					}
					
					if(isset($accommodationDetails['sql']) && isset($accommodationDetails['valueArray'])){
						
						#$updateSql = $accommodationDetails['sql'];
						#$updateValue = $accommodationDetails['valueArray'];
						$checkIn = $accommodationDetails['checkIn'];
						$checkOut = $accommodationDetails['checkOut'];
						$deleteSql = "SELECT * FROM `".$table_name."` WHERE `accountKey` = %d AND (`unixTime` >= %d AND `unixTime` <= %d) ORDER BY `unixTime` ASC ;";
						$deleteValue = array(intval($accountKey), intval($oldTimeStart), intval($oldTimeEnd));
						unset($accommodationDetails['sql']);
						unset($accommodationDetails['valueArray']);
						
					}
					#var_dump($wpdb->prepare($updateSql, $updateValue));
					#var_dump($wpdb->prepare($deleteSql, $deleteValue));
					
					/**
					if($status == "approved"){
						
						$this->updateRemainderSeart("delete", $deleteSql, $deleteValue, $applicantCount);
						$this->updateRemainderSeart("increase", $updateSql, $updateValue, $applicantCount);
						
					}
					**/
					
					$this->updateRemainderSeart("delete", $deleteSql, $deleteValue, $applicantCount);
					$this->updateRemainderSeart("increase", $updateSql, $updateValue, $applicantCount);
					
					$updateValue = array(
                            			'scheduleUnixTime' => intval($scheduleDetail['unixTime']), 
                            			'scheduleWeek' => intval($scheduleDetail['weekKey']), 
                            			'scheduleTitle' => $scheduleDetail['title'], 
                            			'scheduleCost' => intval($scheduleDetail['cost']), 
                            			'scheduleKey' => intval($scheduleDetail['key']),
                            			'checkIn' => intval($checkIn),
                            			'checkOut' => intval($checkOut),
                            			'accommodationDetails' => json_encode($accommodationDetails)
                            		);
					
					if($newCourseTime != $oldCourseTime){
						
						$updateValue['courseKey'] = "exception";
						$updateValue['courseName'] = $newCourseTime." min";
						$updateValue['courseTime'] = intval($newCourseTime);
						
					}
					
					$table_name = $wpdb->prefix."booking_package_userPraivateData";
    				$bool = $wpdb->update(  $table_name,
                    	        			$updateValue,
                    	        			array('key' => intval($updateKey)),
                    	        			array('%d', '%d', '%s', '%d', '%d', '%d', '%d', '%s', '%s', '%s', '%d'),
                    	        			array('%d')
							);
					
				}else{
					
					return $changeBool;
					
				}
				
				
				
			}
    		
    	}
    	
    	public function updatePraivateData($id, $form){
    		
    		global $wpdb;
    		$form = json_encode($form);
    		$table_name = $wpdb->prefix."booking_package_userPraivateData";
    		$bool = $wpdb->update(  $table_name,
                           			array(
                           				'praivateData' => $form
                           				),
                           			array('key' => intval($id)),
                           			array('%s'),
                           			array('%d')
					);
    		
    	}
    	
    	public function updateRemainderSeart($mode, $sql, $valueArray, $applicantCount = 1){
    		
    		if(is_null($sql)){
    			
    			return false;
    			
    		}
    		
    		global $wpdb;
    		$updateSchedule = array();
    		if($mode == "increase"){
    			
    			$sql = $wpdb->prepare($sql, $valueArray);
				$rows = $wpdb->get_results($sql, ARRAY_A);
				$valueArray = array();
				foreach($rows as $row){
					
					
					$waitingRemainder = 0;
					$remainder = $row['remainder'] - $applicantCount;
					if($row['stop'] == 'false' && $remainder >= 0){
						
						if(0 < $row['waitingRemainder']){
							
							$waitingRemainder = $row['waitingRemainder'] - $applicantCount;
							
						}
						
						array_push($valueArray, array('remainder' => intval($remainder), 'waitingRemainder' => intval($waitingRemainder), 'key' => intval($row['key'])));
						
					}else{
						
						return array('status' => 'error', 'error' => '9503');
						
					}
					
				}
				
				$table_name = $wpdb->prefix."booking_package_schedule";
				for($i = 0; $i < count($valueArray); $i++){
					
					$data = $valueArray[$i];
					$bool = $wpdb->update(  $table_name,
                           			array('remainder' => $data['remainder'], 'waitingRemainder' => $data['waitingRemainder']),
                           			array('key' => $data['key']),
                           			array('%d', '%d'),
                           			array('%d')
					);
					
					array_push($updateSchedule, $bool);
					
				}
    			
    		}else{
    			
    			$table_name = $wpdb->prefix."booking_package_schedule";
            	$sql = $wpdb->prepare($sql, $valueArray);
            	$rows = $wpdb->get_results($sql, ARRAY_A);
            	foreach($rows as $row){
            		
            		$remainder = $row['remainder'] + $applicantCount;
					$wpdb->update(  $table_name,
                           			array('remainder' => intval($remainder)),
                           			array('key' => intval($row['key'])),
                           			array('%d'),
                           			array('%d')
					);
            		
            		array_push($updateSchedule, $row['hour'].":".$row['min']." ".$remainder);
            			
            	}
    			
    		}
    		
    		return $updateSchedule;
    		
    	}
    	
    	public function getUserList($unixTime, $accountKey = 1){
    		
    		global $wpdb;
            
            $table_name = $wpdb->prefix."booking_package_userPraivateData";
    		$sql = $wpdb->prepare("SELECT `key`,`scheduleUnixTime`,`scheduleKey`,`courseTime`,`status`,`applicantCount`,`praivateData`,`iCalIDforGoogleCalendar`,`resultOfGoogleCalendar`,`praivateData`,`checkIn`,`checkOut`,`accommodationDetails` FROM ".$table_name." WHERE `iCalIDforGoogleCalendar` IS NOT NULL AND `accountKey` = %d AND `scheduleUnixTime` > %d ORDER BY `key` ASC;", array(intval($accountKey), intval($unixTime)));
            
            $rows = $wpdb->get_results($sql, ARRAY_A);
    		
    		return $rows;
    		
    	}
    	
    	public function getUserValues($accountKey){
    		
    		global $wpdb;
    		
    		$table_name = $wpdb->prefix."booking_package_form";
            $sql = $wpdb->prepare("SELECT * FROM ".$table_name." WHERE `accountKey` = %d;", array(intval($accountKey)));
            $row = $wpdb->get_row($sql, ARRAY_A);
    		$form = json_decode($row['data']);
    		for($i = 0; $i < count($form); $i++){
    			
    			if(isset($_POST['form'.$i])){
    				
    				if($form[$i]->required == 'true' && strlen($_POST['form'.$i]) == 0){
    					
    					return array('status' => 'error', "message" => 'No text or select.', 'form' => $form[$i]);
    					
    				}else{
    					
    					if($form[$i]->isEmail == 'true' && strlen($_POST['form'.$i]) != 0 && !preg_match("/^([a-zA-Z0-9])+([a-zA-Z0-9\._-])*@([a-zA-Z0-9_-])+([a-zA-Z0-9\._-]+)+$/", $_POST['form'.$i])){
    						
    						return array('status' => 'error', "message" => 'The format of the e-mail address is incorrect.', 'form' => $form[$i]);
    						
    					}else{
    						
    						$value = $_POST['form'.$i];
    						if($form[$i]->type == 'TEXTAREA'){
    							
    							$value = sanitize_textarea_field($value);
    							
    						}else{
    							
    							$value = sanitize_text_field($value);
    							
    						}
    						
    						if($form[$i]->isEmail == 'true'){
    							
    							$value = sanitize_email($value);
    							
    						}
    						
    						$form[$i]->value = $value;
    						
    					}
    					
    				}
    				
    			}
    			
    		}
    		
    		return $form;
    		
    	}
    	
    	public function emailFormat($email, $title = null){
    		
    		$value = $email;
    		if(!is_null($title) && strlen($title) != 0){
    			
    			$value = sprintf("%s <%s>", $title, $email);
    			
    		}
    		
    		return $value;
    		
    	}
    	
    	
    	public function dateFormat($dateFormat, $positionOfWeek, $unixTime, $title, $includingTime, $shortString = false){
    		
    		$dateFormat = intval($dateFormat);
    		
    		$monthList = array(__('January'), __('February'), __('March'), __('April'), __('May'), __('June'), __('July'), __('August'), __('September'), __('October'), __('November'), __('December'));
    		
    		$weekNameList = array(__('Sunday'), __('Monday'), __('Tuesday'), __('Wednesday'), __('Thursday'), __('Friday'), __('Saturday'));
    		$weekName = $weekNameList[date('w', $unixTime)];
    		
    		if($shortString == true){
    			
    			$monthList = array(__('Jan'), __('Feb'), __('Mar'), __('Apr'), __('May'), __('Jun'), __('Jul'), __('Aug'), __('Sep'), __('Oct'), __('Nov'), __('Dec'));
    			
    			$weekNameList = array(__('Sun'), __('Mon'), __('Tue'), __('Wed'), __('Thu'), __('Fri'), __('Sat'));
    			$weekName = $weekNameList[date('w', $unixTime)];
    			
    		}
    		
    		
    		if(is_null($title)){
    			
    			$title = '';
    			
    		}
    		
    		$date = date('d/m/Y ', $unixTime);
    		$time = date('H:i', $unixTime)." ".$title;
    		if($includingTime == false){
    			
    			$time = "";
    			
    		}
    		
    		if($dateFormat == 0){
    			
        		$date = date('m/d/Y ', $unixTime);
        		
    		}else if($dateFormat == 1){
    			
		        $date = date('m-d-Y ', $unixTime);
		        
    		}else if($dateFormat == 2){
    			
        		#$date = date('F d, Y', $unixTime);
        		$date = $monthList[date('n', $unixTime) - 1].date(' d, Y', $unixTime);
        		
    		}else if($dateFormat == 3){
    			
        		$date = date('d/m/Y ', $unixTime);
        		
    		}else if($dateFormat == 4){
    			
        		$date = date('d-m-Y ', $unixTime);
        		
    		}else if($dateFormat == 5){
    			
        		#$date = date('d F, Y ', $unixTime);
        		$date = date('d ', $unixTime).$monthList[date('n', $unixTime) - 1].date(', Y', $unixTime);
        		
    		}else if($dateFormat == 6){
    			
        		$date = date('Y/m/d ', $unixTime);
        		
    		}else if($dateFormat == 7){
    			
        		$date = date('Y-m-d ', $unixTime);
        		
    		}
    		
    		if($positionOfWeek == 'before'){
    			
    			$date = $weekName.' '.$date.' '.$time;
    			
    		}else{
    			
    			$date = $date.' '.$weekName.' '.$time;
    			
    		}
    		
    		return $date;
    		
    	}
    	
    	public function createEmailMessage($accountKey, $email_id, $form, $accommodationDetails, $bookingID, $unixTime, $emailSubject, $emailBody, $emailFormat, $to, $from, $service = null, $scheduleTitle = null){
    		
    		global $wpdb;
    		
    		$to = $this->emailFormat(get_option($this->prefix."email_to", null), get_option($this->prefix."email_title_to", null));
    		$from = $this->emailFormat(get_option($this->prefix."email_from", null), get_option($this->prefix."email_title_from", null));
    		
    		$table_name = $wpdb->prefix."booking_package_emailSetting";
    		for($i = 0; $i < count($email_id); $i++){
    			
    			$sql = $wpdb->prepare("SELECT * FROM ".$table_name." WHERE `accountKey` = %d AND `mail_id` = %s;", array(intval($accountKey), $email_id[$i]));
                $row = $wpdb->get_row($sql, ARRAY_A);
                if(intval($_POST['sendEmail']) == 1){
                	
                	$emailSubject = $row['subject'];
                	$emailBody = $row['content'];
                	$emailFormat = $row['format'];
                	if(intval($row['enable']) == 0){
                		
                		return null;
                		
                	}
                	
                }
    			
    		}
    		
    		$mailBody = stripslashes($mailBody);
    		$emailBody = preg_replace('/\\\/u', "", $emailBody);
    		
    		$site_name = get_option($this->prefix."site_name", "");
    		$dateFormat = intval(get_option($this->prefix."dateFormat", 0));
    		$positionOfWeek = get_option($this->prefix."positionOfWeek", "before");
    		$date = $this->dateFormat($dateFormat, $positionOfWeek, $unixTime, $scheduleTitle, true, false);
    		if (preg_match('/(\[date\])/', $emailBody, $matches)) {
    			
    			$emailBody = preg_replace('/(\[date\])/', $date, $emailBody);
    			
    		}
    		
    		if (preg_match('/(\[checkIn\])/', $emailBody, $matches)) {
    			
    			$date = $this->dateFormat($dateFormat, $positionOfWeek, $accommodationDetails['checkIn'], $scheduleTitle, false, false);
    			$emailBody = preg_replace('/(\[checkIn\])/', $date, $emailBody);
    			
    		}
    		
    		if (preg_match('/(\[checkOut\])/', $emailBody, $matches)) {
    			
    			$date = $this->dateFormat($dateFormat, $positionOfWeek, $accommodationDetails['checkOut'], $scheduleTitle, false, false);
    			$emailBody = preg_replace('/(\[checkOut\])/', $date, $emailBody);
    			
    		}
    		
    		if (preg_match('/(\[guests\])/', $emailBody, $matches)) {
    			
    			$guestsDetails = array();
    			$guestsList = $accommodationDetails['guestsList'];
    			foreach($guestsList as $key => $value){
    				
    				$name = $value['name'];
    				$guests = $value['json'];
    				for($i = 0; $i < count($guests); $i++){
    					
    					if(intval($guests[$i]['selected']) == 1){
    						
    						array_push($guestsDetails, $name.": ".$guests[$i]['name']);
    						break;
    						
    					}
    					
    				}
    				
    			}
    			$guestsDetails = implode("\n", $guestsDetails);
    			$emailBody = preg_replace('/(\[guests\])/', $guestsDetails, $emailBody);
    			
    		}
    		
    		if (preg_match('/(\[id\])/', $emailBody, $matches)) {
    			
    			$emailBody = preg_replace('/(\[id\])/', $bookingID, $emailBody);
    			
    		}
    		
    		if (preg_match('/(\[site_name\])/', $emailBody, $matches)) {
    			
    			$emailBody = preg_replace('/(\[site_name\])/', $site_name, $emailBody);
    			
    		}
    		
    		if(!is_null($service) && strlen($service) != 0){
    			
    			if(preg_match('/(\[service\])/', $emailBody, $matches)) {
    				
    				$emailBody = preg_replace('/(\[service\])/', $service, $emailBody);
    				
    			}
    			
    		}
    		
    		
    		
    		$visitorEmail = array();
    		$content = "";
    		for($i = 0; $i < count($form); $i++){
    			
    			
    			if($emailFormat == "text"){
    				
    				$content .= $form[$i]->name."\r\n".$form[$i]->value."\r\n";
    				
    			}else{
    				
    				$content .= '<div style="width: 100%; display: table;"><div style="width: 30%; display: table-cell; vertical-align: middle;">'.$form[$i]->name.'</div><div style="width: 70%; display: table-cell; vertical-align: middle;">'.$form[$i]->value.'</div></div>';
    				#$content .= '<div style="width: 30%; display: table-cell; vertical-align: middle;">'.$form[$i]->name.'</div><div style="width: 70%; display: table-cell; vertical-align: middle;">'.$form[$i]->value.'</div>';
    				
    			}
    			
    			if($form[$i]->isEmail == 'true'){
    				
    				array_push($visitorEmail, $form[$i]->value);
    				
    			}
    			
    		}
    		
    		if (preg_match('/(\[content\])/', $emailBody, $matches)) {
    			
    			$emailBody = preg_replace('/(\[content\])/', $content, $emailBody);
    			
    		}
    		
    		for($i = 0; $i < count($form); $i++){
    			
    			$id = '\['.$form[$i]->id.'\]';
    			#$value = $form[$i]->name."\n".$form[$i]->value."\n";
    			$value = $form[$i]->value."\n";
    			if (preg_match('/('.$id.')/', $emailBody, $matches)) {
    				
    				$emailBody = preg_replace('/('.$id.')/', $value, $emailBody);
    			
    			}
    			
    		}
    		
    		$headers = array("From: ".$from."\r\n", "Return-Path: ".$from."\r\n", "Reply-To: ".$from."\r\n");
    		
    		if($emailFormat == "text"){
    			
    			$emailBody = strip_tags($emailBody);
    			
    		}else{
    			
    			array_push($headers, "Content-Type: text/html; charset=UTF-8");
    			$bodyStyle = 'word-wrap: break-word; white-space: pre;';
    			$header = '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">';
    			$header .= '<html xmlns="http://www.w3.org/1999/xhtml"><head><meta http-equiv="Content-Type" content="text/html; charset=UTF-8" /><title>Booking email</title></head>';
    			$header .= '<body style="'.$bodyStyle.'">';
    			$emailBody = $header.$emailBody."</body></html>";
    			
    		}
    		
    		$responseList = array('body' => $emailBody, 'to' => $to, 'from' => $from, 'sendVisitor' => $sendVisitor, 'headers' => $headers, 'visitorEmail' => $visitorEmail, 'response' => array(), 'params' => array());
    		
    		mb_language("uni");
			mb_internal_encoding("UTF-8");
    		
    		$mailgun_active = intval(get_option($this->prefix."mailgun_active", 0));
    		if($mailgun_active == 1){
    			
    			$mailgun_aip_base_url = get_option($this->prefix."mailgun_aip_base_url", 0);
    			$mailgun_api_key = get_option($this->prefix."mailgun_api_key", 0);
    			$mailgun_password = get_option($this->prefix."mailgun_password", 0);
    			#var_dump($mailgun_api_key);
    			
    			$params = array('from' => $from, 'to' => implode(",", $visitorEmail), 'subject' => $emailSubject);
    			if($emailFormat == "text"){
					
					$params['text'] = $emailBody;
					
				}else{
					
					$params['html'] = $emailBody;
					
				}
				$responseList['params']['visitor'] = $params;
    			if(count($visitorEmail) != 0){
    				
					$paramsQuery = http_build_query($params);
					#$params = json_encode($params);
					$context = array(
						'http' => array(
							'method' => 'POST', 
							'header' => "Content-Type: application/x-www-form-urlencoded\r\n".
							"Content-Length: ".strlen($paramsQuery)."\r\n".
							"User-Agent: PHP\r\n".
							"Host: api.mailgun.net\r\n".
							"Authorization: Basic ".base64_encode("api:".$mailgun_api_key),
							'content' => $paramsQuery
						)
					);
					
					$context = stream_context_create($context);
					$response = file_get_contents($mailgun_aip_base_url.'/messages', false, $context);
					$responseList['response']['visitor'] = $response;
					
    			}
    			
    			$params['to'] = $to;
    			$responseList['params']['admin'] = $params;
    			$paramsQuery = http_build_query($params);
				$context = array(
					'http' => array(
						'method' => 'POST', 
						'header' => "Content-Type: application/x-www-form-urlencoded\r\n".
						"Content-Length: ".strlen($paramsQuery)."\r\n".
						"User-Agent: PHP\r\n".
						"Host: api.mailgun.net\r\n".
						"Authorization: Basic ".base64_encode("api:".$mailgun_api_key),
						'content' => $paramsQuery
					)
				);
				
				$context = stream_context_create($context);
				$response = file_get_contents($mailgun_aip_base_url.'/messages', false, $context);
				$responseList['response']['admin'] = $response;
    			
    		}else{
    			
    			$sendVisitor = false;
    			if(count($visitorEmail) != 0){
    				
    				$sendVisitor = wp_mail($visitorEmail, $emailSubject, $emailBody, $headers);
    				$responseList['sendVisitor'] = $sendVisitor;
    				
    			}
    			$sendControl = wp_mail($to, $emailSubject, $emailBody, $headers);
    			$responseList['sendControl'] = $sendControl;
    			
    		}
    		
    		$responseList['mailgun_active'] = $mailgun_active;
    		return $responseList;
    		
    	}
    	
    	public function scriptError(){
    		
    		$url = BOOKING_PACKAGE_EXTENSION_URL;
    		$response = array('status' => 'success', 'url' => $url);
    		
			$params = array(
				'mode' => 'scriptError',
				'url' => sanitize_text_field($_POST['url']), 
				'file' => sanitize_text_field($_POST['file']), 
				'msg' => sanitize_text_field($_POST['msg']),
				'line' => sanitize_text_field($_POST['line']), 
				'col' => sanitize_text_field($_POST['col']),
				'version' => sanitize_text_field($_POST['version']),
				'code' => sanitize_text_field($_POST['code']),
				'browser' => sanitize_text_field($_POST['browser']),
			);
			$response['params'] = $params;
			
			$ch = curl_init();
        	curl_setopt($ch, CURLOPT_URL, "https://saasproject.net/lib/scriptError.php");
        	curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($params));
        	curl_setopt($ch, CURLOPT_POST, 1);
        	
        	ob_start();
        	$response = curl_exec($ch);
        	$response = ob_get_contents();
        	ob_end_clean();
        	$httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
        	curl_close ($ch);
        	$response = json_decode($response, true);
    		
    		return $response;
    		
    	}
        
        
    }
    
    
    
    
    
    
?>